#include <h8/syscall.h>
#include <h8/printf.h>
#include <string.h>
#define MAX_BUF	88
#define MAX_ARG	40

#include <h8/reg3067.h> // for WDT(TCNT) by kishida koji
//#include <sh/reg705x.h>

static int	*sysargs, callnum, ta_count, spsave;
static char	com[MAX_BUF], *coms[MAX_ARG], prompt[16];

int err_message() {
	write_string("\nCommand not found, or syntax error!\n");
}

int main() {
	int	a, n, i, count, num, addr, addr2, data, chksum, mask;
	void	(*jump)();
	unsigned char	*mac, buf[10], c;
	unsigned char	*ptr, *p;
	unsigned short	*pw;

//	PFCR1 = 0;
//	PFCR2 = 0;
//	PFIOR = 0x0400;
//	PFDR = 0x0000;
	sio_speed(57600, FREQ);
	write_string("Welcome to the H8 Monitor!!\n");
	strcpy(prompt, "\nH8/OS >");
	ptr = com;
	write_string(prompt);
	while(1) {
		TCNT = 0x5a00 ;  // for WDT by kishida koji
		if((int)ptr >= (int)(com + MAX_BUF)) ptr = &com[MAX_BUF - 1];
		n = sys_read(ptr, 1);
//	PFDR = 0x0400;
		if(n < 1) continue;
		if(*ptr >= 0x80) continue;
		if(*ptr != '\r') {
			if(*ptr == 0x7f) *ptr = 8;
			if(*ptr == 8) {
				if((int)ptr > (int)com) {
					sys_write(ptr, 1);
					ptr--;
				}
				continue;
			}
			sys_write(ptr, 1);
			ptr++;
			continue;
		}
		*ptr = 0;
		ptr = com;
		i = count = 0;
		coms[count++] = &(com[i]);
		while(com[i] != 0) {
			if(com[i] == ' ') {
				com[i] = 0;
				coms[count++] = &(com[i + 1]);
			}
			i++;
		}
		if(count >= MAX_ARG) {
			err_message();
		} else if(strcmp(coms[0], "dump") == 0 && count <= 2) {
			if(count == 2) num = atohex(coms[1]);
			if(num == -1) {
				err_message();
			} else {
				write_string("\n");
				n = num + 16 * 8;
				while(num < n) {
					TCNT = 0x5a00 ;  // for WDT by kishida koji
					write_mode(BINARY);
					sys_write((char*)(&num), 4);
					write_mode(ASCII);
					write_string(" : ");
					write_mode(BINARY);
					sys_write((char*)num, 8);
					num += 8;
					write_mode(ASCII);
					write_string("  ");
					write_mode(BINARY);
					sys_write((char*)num, 8);
					write_mode(ASCII);
					write_string("\n");
					num += 8;
				}
			}
		} else if(strcmp(coms[0], "setbyte") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				err_message();
			} else {
				p = (unsigned char *)addr;
				num &= 0xff;
				write_string("\n    ");
				write_mode(BINARY);
				sys_write(p, 1);
				write_mode(ASCII);
				write_string(" -> ");
				*p = (char)num;
				write_mode(BINARY);
				sys_write(p, 1);
				write_mode(ASCII);
				write_string(" updated.\n");
			}
		} else if(strcmp(coms[0], "setword") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				err_message();
			} else {
				pw = (unsigned short *)addr;
				num &= 0xffff;
				write_string("\n    ");
				write_mode(BINARY);
				sys_write((char*)pw, 2);
				write_mode(ASCII);
				write_string(" -> ");
				*pw = (unsigned short)num;
				write_mode(BINARY);
				sys_write((char*)pw, 1);
				write_mode(ASCII);
				write_string(" updated.\n");
			}
		} else if(strcmp(coms[0], "setdata") == 0 && count >= 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1 || count != num + 3) {
				err_message();
			} else {
				p = (unsigned char *)addr;
				for(i = 0;i < num;i++) {
					data = atohex(coms[i + 3]);
					*p = (char)data;
					p++;
				}
				write_string(".");
			}
		} else if(strcmp(coms[0], "clear") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				err_message();
			} else {
				p = (unsigned char*)addr;
				for(i = 0;i < num;i++) {
					p[i] = 0;
				}
				write_string("\n    mamory cleared.\n");
			}
		} else if(strcmp(coms[0], "prompt") == 0 && count == 2) {
			strncpy(prompt + 1, coms[1], 12);
			strcat(prompt, " >");
			write_string("\n\n");
		} else if(strcmp(coms[0], "memcheck") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				err_message();
			} else {
				write_string("\n");
				p = (unsigned char *)addr;
				for(i = 0;i < num;i++) {
					chksum = (addr + i) & 0xff;
					chksum += ((addr + i) >> 8) & 0xff;
					chksum += ((addr + i) >> 16) & 0xff;
					*p = (char)chksum;
					p++;
				}
				p = (unsigned char *)addr;
				for(i = 0;i < num;i++) {
					TCNT = 0x5a00 ;  // for WDT by kishida koji
					chksum = (addr + i) & 0xff;
					chksum += ((addr + i) >> 8) & 0xff;
					chksum += ((addr + i) >> 16) & 0xff;
					c = (char)chksum;
					if(c != *p) {
						data = addr + i;
						write_mode(BINARY);
						sys_write((char*)(&data), 4);
						write_mode(ASCII);
						write_string(" : check error!!\n");
					}
					p++;
				}
				write_string("memory checked.\n");
			}
#ifndef H8_3664
		} else if(strcmp(coms[0], "sromsetup") == 0 && count == 5) {
#ifdef SH2
			volatile short	*dr, *ddr;
			short		bits[3];
			dr = (volatile short*)atohex(coms[1]);
			ddr = (volatile short*)atohex(coms[2]);
#else
			volatile char	*dr, *ddr;
			char		bits[3];
			dr = (volatile char*)atohex(coms[1]);
			ddr = (volatile char*)atohex(coms[2]);
#endif
			for(i = 0;i < 2;i++) {
				num = atohex(coms[3 + i]);
				bits[i] = num;
			}
#ifdef SH2
			eep_setupw(dr, ddr, bits);
#else
			eep_setup(dr, ddr, bits);
#endif
			write_string("\nserial eeprom setuped.");
		} else if(strcmp(coms[0], "ifconfig") == 0) {
			if(count == 1) {
				n = get_ipinfo(&addr, &mask);
				mac = get_mac_address();
				if(n) {
					write_string("\nLink encap:Ethernet  HWaddr ");
					for(i = 0;i < 6;i++) {
						write_mode(BINARY); sys_write(&(mac[i]), 1);
						write_mode(ASCII); write_string(":");
					}
					write_string("\ninet addr:");
					for(i = 3;i >= 0;i--) {
						write_decimal((addr >> (i * 8)) & 0xff);
						write_string(".");
					}
					write_string("  Mask:");
					for(i = 3;i >= 0;i--) {
						write_decimal((mask >> (i * 8)) & 0xff);
						write_string(".");
					}
					write_string("\n");
				}
			} else if(count == 6) {
				n = get_ipinfo(&addr, &mask);
				if(n == 0) {
					addr = 0xc0a80001;
					mask = 0xffffff00;
				}
				if(strcmp(coms[1], "inet") == 0) {
					addr = 0;
					for(i = 2;i < 6;i++) {
						addr <<= 8;
						addr |= atodec(coms[i]) & 0xff;
					}
					ip_setup(addr, mask);
				} else if(strcmp(coms[1], "mask") == 0) {
					mask = 0;
					for(i = 2;i < 6;i++) {
						mask <<= 8;
						mask |= atodec(coms[i]) & 0xff;
					}
					ip_setup(addr, mask);
				} else if(strcmp(coms[1], "gw") == 0) {
					addr = 0;
					for(i = 2;i < 6;i++) {
						addr <<= 8;
						addr |= atodec(coms[i]) & 0xff;
					}
					set_gateway(addr);
				} else {
					err_message();
				}
			} else {
				err_message();
			}
		} else if(strcmp(coms[0], "setmac") == 0 && count == 7) {
			for(i = 1;i <= 6;i++) {
				num = atohex(coms[i]);
				if(num > 0xff) err_message();
				buf[i - 1] = num;
			}
			a = ether_setmac(buf);
			if(a == 0) {
				ether_getmac(buf);
				write_string("\n ");
				write_mode(BINARY);
				sys_write(buf, 6);
				write_mode(ASCII);
				write_string(" modified mac enables when reset.\n");
			} else {
				write_string("\n ethernet controler is disabled!\n");
			}
		} else if(strcmp(coms[0], "ethbase") == 0 && count == 2) {
			num = atohex(coms[1]);
			if(num == -1) {
				err_message();
			} else {
				ether_init(num);
				write_string("\n set ether base adddress..\n");
			}
		} else if(strcmp(coms[0], "atasetup") == 0 && count == 3) {
			addr = atohex(coms[1]);
			if(addr == -1) {
				err_message();
			}
			addr2 = atohex(coms[2]);
			if(addr2 == -1) {
				err_message();
			}
			write_string("\n");
			c = ata_setup(addr, addr2);
			if(c == 0) {
				write_string("HDD not found!!\n");
			} else {
				if(c & 1) write_string("HDD#0 ");
				if(c & 2) write_string("HDD#1 ");
				write_string("is enable\n");
			}
		} else if(strcmp(coms[0], "hddprobe") == 0 && count == 1) {
			char	name[40];
			int	pio, capa, chs[3];

			for(i = 0;i < 2;i++) {
				ata_sel_drive(i);
				pio = ata_driveinfo(name, chs);
				if(pio != -1) {
					write_string("\n");
					sys_write(name, 40);
					write_string("\n");
					write_string("HEAD:");
					write_decimal(chs[0]);
					write_string(" CYLINDER:");
					write_decimal(chs[1]);
					write_string(" SECTOR:");
					write_decimal(chs[2]);
					write_string("\n");
					write_string("PIO mode");
					write_decimal(pio);
					write_string("\n");
					capa = get_hddsize();
					capa >>= 11;
					printf("hdd size is %dMbyte\n", capa);
				}
			}
			ata_sel_drive(0);
#endif
		} else if(strcmp(coms[0], "exec") == 0 && count <= 2) {
			if(count == 2)
				jump = (void*)atohex(coms[1]);
			else
#ifdef H8_300H
				jump = (void*)0xfff600;
#endif
#ifdef H8_3664
				jump = (void*)0xf9b0;
#endif
#ifdef SH2
				jump = (void*)0xfffff780;
#endif
			(*jump)();
			read_mode(SIO);
			write_mode(SIO);
			write_mode(ASCII);
#ifndef H8_3664
			timer1_unregist();
			timer2_unregist();
			timer3_unregist();
#endif
			write_string("\n executed.\n");
		} else {
			err_message();
		}
		write_string(prompt);
	}
}
