OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	syscall(r) : o = 0x000100, l = 0x0200
	ram(rwx)   : o = 0xfff440, l = 0x0800
}
SECTIONS 				
{ 					
.syscall 0x100: {
	_sys_write	= . +  0;
	_write_string	= . +  4;
	_write_mode	= . +  8;
	_set_membuf	= . +  8;
	_sys_read	= . + 12;
	_read_string	= . + 16;
	_sio_speed	= . + 20;
	_atohex		= . + 24;
	_lcd_clear	= . + 28;
	_lcdsetup	= . + 32;
	_timer1_regist	= . + 36;
	_timer1_unregist = . + 40;
	_timer2_regist	= . + 44;
	_timer2_unregist = . + 48;
	_timer3_regist	= . + 52;
	_timer3_unregist = . + 56;
	_sleep		= . + 60;
	_ether_write	= . + 64;
	_ether_flush	= . + 68;
	_ether_read	= . + 72;
	_ether_setup	= . + 76;
	_ether_get	= . + 80;
	_get_ether_status = . + 84;
	_get_mac_address = . + 88;
	_ip_setup	= . + 92;
	_query_mac	= . + 96;
	_write_decimal	= . + 100;
	_atodec		= . + 104;
	_get_ipinfo	= . + 108;
	_ether_setmac	= . + 112;
	_ether_getmac	= . + 116;
	_udp_regport	= . + 120;
	_udp_unregport	= . + 124;
	_udp_read	= . + 128;
	_udp_write	= . + 132;
	_save_regport	= . + 136;
	_recover_regport = . + 140;
	_set_udpaddr	= . + 144;
	_tcpsocket	= . + 148;
	_tcp_regport	= . + 152;
	_tcp_unregport	= . + 156;
	_set_tcpaddr	= . + 160;
	_tcp_read	= . + 164;
	_tcp_write	= . + 168;
	_tcp_status	= . + 172;	
	_tcpclose	= . + 176;
	_ether_init	= . + 180;
	_ata_setup	= . + 184;
	_int_regist	= . + 188;
	_int_unregist	= . + 192;
	_ata_sel_drive	= . + 196;
	_ata_reset	= . + 200;
	_non_data_command = . + 204;
	_ata_identify	= . + 208;
	_data_in_command = . + 212;
	_ata_driveinfo	= . + 216;
	_data_out_command = . + 220;
	_get_hddsize	= . + 224;
	_set_gateway	= . + 228;
	_ps2_setup	= . + 232;
	_key_read	= . + 236;
	_nmi_edge	= . + 240;
	_read_mode	= . + 244;
	_eep_setup	= . + 248;
	_eep_write	= . + 252;
	_eep_read	= . + 256;
	_dirent_init	= . + 260;
	_dirent_get	= . + 264;
	_makedir	= . + 268;
	_openfile	= . + 272;
	_readfile	= . + 276;
	_writefile	= . + 280;
	_closefile	= . + 284;
	_delete		= . + 288;
	_renfile	= . + 292;
	_get_file_size	= . + 296;
	_format		= . + 300;
	_print		= . + 316;
	_sprint		= . + 320;
	_scan		= . + 324;
	_sscan		= . + 328;
	_bussize_setup	= . + 332;
	_cs_setup	= . + 336;
	_rtc_setup	= . + 340;
	_rtc_read	= . + 344;
	_rtc_write	= . + 348;
	_mem_size	= . + 352;
	_sio_change	= . + 356;
	_easy_max	= . + 360;
	_easy_dir	= . + 364;
	_easy_format	= . + 368;
	_easy_find	= . + 372;
	_easy_del	= . + 376;
	_easy_create	= . + 380;
	_easy_write	= . + 384;
	_easy_read	= . + 388;
	_get_eepsize	= . + 392;
 	_putch		= . + 396;
 	_getch		= . + 400;
        }  > syscall
.text :	AT (0) {
	*(.text)
	*(.strings)
	*(.rodata)
   	 _etext = . ; 
	}  > ram
.tors : AT (SIZEOF(.text)) {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > ram
.data : AT (SIZEOF(.text) + SIZEOF(.tors)) {
	*(.data)
	 _edata = . ; 
	}  > ram
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
}
