#ifdef H8_3052
  #include "rom3052.h"
  #define CODE_AREA	((void*)0xffdf20)
  #define BLK_SIZ	128
#endif
#ifdef H8_3068
  #include "rom3068.h"
  #define CODE_AREA	((void*)0xffbf20)
  #define BLK_SIZ	128
#endif
#ifdef SH2_7045
  #include "rom7045.h"
  #define CODE_AREA	((void*)0xfffff7a0)
  #define BLK_SIZ	32
#endif

int write_flush(char *target, char *source, int size) {
	int	i, mod;
	unsigned int reg;
	char	buffer[128], *ptr;
	char	(*write_flush)(char*, char*);

	write_flush = CODE_AREA;
	ptr = (char*)((int)target & ~0x7f);
	mod = (int)target % 128;
	if(size + mod > 128) return -1;
	for(i = 0;i < 128;i++) buffer[i] = ptr[i];
	for(i = 0;i < size;i++) buffer[i + mod] = source[i];
#ifdef SH2
	asm("	stc	sr,%0":"=r"(reg):);
	reg |= 0x000000f0;
	asm("	ldc	%0,sr"::"r"(reg));
#else
	asm("orc.b\t#128,ccr");
#endif
	memcpy(CODE_AREA, writecode, 0x400);
	for(i = 0;i < 128;i += BLK_SIZ) {
		if((*write_flush)(&(ptr[i]), &(buffer[i])) != 0) {
#ifdef SH2
			asm("	stc	sr,%0":"=r"(reg):);
			reg &= 0xffffff0f;
			asm("	ldc	%0,sr"::"r"(reg));
#else
			asm("andc.b\t#127,ccr");
#endif
			return -1;
		}
	}
	bzero(CODE_AREA, 0x400);
#ifdef SH2
	asm("	stc	sr,%0":"=r"(reg):);
	reg &= 0xffffff0f;
	asm("	ldc	%0,sr"::"r"(reg));
#else
	asm("andc.b\t#127,ccr");
#endif
	return 0;
}

int erase_flush(char *address) {
	char	(*erase_flush)(char*);
	int	ret;
	unsigned int reg;

	erase_flush = CODE_AREA;
#ifdef SH2
	asm("	stc	sr,%0":"=r"(reg):);
	reg |= 0x000000f0;
	asm("	ldc	%0,sr"::"r"(reg));
#else
	asm("orc.b\t#128,ccr");
#endif
	memcpy(CODE_AREA, erasecode, 0x400);
	ret = (*erase_flush)(address);
	bzero(CODE_AREA, 0x400);
#ifdef SH2
	asm("	stc	sr,%0":"=r"(reg):);
	reg &= 0xffffff0f;
	asm("	ldc	%0,sr"::"r"(reg));
#else
	asm("andc.b\t#127,ccr");
#endif
	return (ret == 0) ? 0 : -1;
}
