#define		SECSIZE	512

#define		SYS_IDENT	0x03
#define		SYS_IDENT_LEN	8
#define		SS		0x0b
#define		SC		0x0d
#define		RSC		0x0e
#define		FN		0x10
#define		RDE		0x11
#define		TS		0x13
#define		MEDIA_IDENT	0x15
#define		SF		0x16
#define		SPT		0x18
#define		NOS		0x1a
#define		SIG		0x36
#define		SIG32		0x52

#define		RDSC		0x2c
#define		TS32		0x20
#define		SF32		0x24

#define		FNAME		0
#define		FATTR		0x0b
#define		FCLUSTOR2	0x14
#define		FTIME		0x16
#define		FDATE		0x18
#define		FCLUSTOR	0x1a
#define		FSIZE		0x1c
#define		ID_MASK		0x3f
#define		END_MASK	0x40

#define		FATTR_DIR	0x10

#define		PATHSIZ		13*10
#define		ENTSIZ		32

#define		NOFAT	0
#define		FAT12	1
#define		FAT16	2
#define		FAT32	3

#define		EE0	8
#define		HD0	16
#define		HD1	17

typedef struct _diskinfo {
	unsigned int	sector_offset;
	unsigned int	root_dir_entry;
	unsigned int	media_sector;
	unsigned int	fat_sector_size;
	unsigned short	sector_size;
	unsigned short	reserve_sector;
	unsigned short	device_id;
	unsigned char	sector_per_clustor;
	unsigned char	fat_number;
	unsigned char	media_ident;
	unsigned char	fat;
} diskinfo;

typedef struct _fileinfo {
	unsigned int	dir_fat;
	unsigned int	top_fat;
	unsigned int	cur_fat;
	unsigned int	sec_off;
	unsigned int	size;
	unsigned int	cur_size;
	unsigned int	dirent;
	char		name[PATHSIZ];
} fileinfo;
