#include "i2c.h"

#define TIMEOVER 40000
volatile REGTYPE*	i2c_regp[2];
volatile REGTYPE*	i2c_ddrp[2];
REGTYPE			i2c_bits[2][2];
int			timeover;

void i2c_start(int device) {
	I2CDDR |= SDA;	/* SDAϤˤ */
	I2CDR &= ~SCL;	/* SCL=L (TLOW = 1600ns) */
	I2CDR |= SDA;	/* SDA=H */
	I2CDR |= SCL;	/* SCL=H (THIGH = 1600ns) */
	I2CDR &= ~SDA;	/* SCL=HSDAH->L : start condition */
	I2CDR &= ~SCL;	/* SCL=L (TLOW > 2000ns) */
	I2CDDR &= ~SDA;	/* SDA()ˤ */
}

void i2c_stop(int device) {
	I2CDDR |= SDA;	/* SDAϤˤ */
	I2CDR &= ~SCL;	/* SCL=L (TLOW = 1600ns) */
	I2CDR &= ~SDA;	/* SDA=L */
	I2CDR |= SCL;	/* SCL=H (THIGH = 1600ns) */
	I2CDR |= SDA;	/* SCL=HSDAL->H : stop condition */
	I2CDR &= ~SCL;	/* SCL=L (TLOW > 2000ns) */
	I2CDDR &= ~SDA;	/* SDA()ˤ */
}

/* i2c_write (ޥȥ󥹥ߥå)
   ACK_BIT(rw_dat.0)˼¹Է(0:ACK / 1:NAK)ꤵ */
int i2c_write(int data, int device) {
	int	i, mask;

	I2CDDR |= SDA;		/* SDAϤˤ */
	mask = 0x80;
	for(i = 0;i < 8;i++) {
		/* data7bitܤ (TSU:DAT = 8001600ns) */
		if(data & mask) I2CDR |= SDA;
		else I2CDR &= ~SDA;
		I2CDR |= SCL;	/* SCL=H (THIGH = 1600ns) */
		I2CDR &= ~SCL;/* SCL=L (TLOW = 24004000ns) */
		mask >>= 1;
	}
	I2CDDR &= ~SDA;	/* SDA()ˤ */
	I2CDR |= SCL;	/* SCL=H (THIGH = 2400ns) */
	i = I2CDR & SDA;
	I2CDR &= ~SCL;	/* SCL=L */
	return i;
}

/* i2c_read (ޥ쥷) */
int i2c_read(int device) {
	int	i, data;

	data = 0;
	for(i = 0;i < 8;i++) {
		data <<= 1;
		I2CDR |= SCL;	/* SCL=H (THIGH = 2800ns) */
		if(I2CDR & SDA) data++;
		I2CDR &= ~SCL;/* SCL=L(TLOW = 1600ns) */
	}
	return data;
}

/* 쥷ФACK/NAC */
void i2c_ack(int device) {
	I2CDDR |= SDA;	/* SDAϤˤ */
	I2CDR &= ~SDA;	/* ACK (TSU:DAT = 800ns) */
	I2CDR |= SCL;	/* SCL=H (THIGH = 800ns) */
	I2CDR &= ~SCL;	/* SCL=L */
	I2CDDR &= ~SDA;	/* SDA()ˤ */
}

void i2c_nak(int device) {
	I2CDDR |= SDA;	/* SDAϤˤ */
	I2CDR |= SDA;	/* NO ACK (TSU:DAT = 800ns) */
	I2CDR |= SCL;	/* SCL=H (THIGH = 800ns) */
	I2CDR &= ~SCL;	/* SCL=L */
	I2CDDR &= ~SDA;	/* SDA()ˤ */
}

int i2c_status(int device) {
	return I2CDR & SDA;	
}

int send_ctrl(int ctrl, int device) {
	int	ret, count;

	count = 0;
	do {
		i2c_start(device);
		ret = i2c_write(ctrl, device);
		if(count++ > timeover) return -1;
	} while(ret == NAK);
	return 0;
}
