#ifdef H8_3048
  #include <h8/reg3048.h>
#endif
#ifdef H8_3664
  #include <h8/reg3664.h>
#endif
#ifdef H8_3067
  #include <h8/reg3067.h>
#endif
#ifdef H8_3664
 static void (*int_proc[18])();
#else
 static void (*int_proc[47])();
#endif

#ifdef H8_3067
int int_table_3067(int num) {
	int	index;

	index = -1;
	if(num >= 7 && num <= 17) {
		index = num - 7;
	} else if(num >= 20 && num <= 21) {
		index = num - 9;
	} else if(num >= 23 && num <= 26) {
		index = num - 10;
	} else if(num >= 28 && num <= 30) {
		index = num - 11;
	} else if(num >= 32 && num <= 34) {
		index = num - 12;
	} else if(num >= 36 && num <= 47) {
		index = num - 13;
	} else if(num >= 52 && num <= 63) {
		index = num - 17;
	}
	return index;
}	
#endif

#ifdef H8_3664
int int_table_3664(int num) {
	int	index;

	index = -1;
	if(num >= 7 && num <= 19) {
		index = num - 7;
	} else if(num >= 21 && num <= 25) {
		index = num - 8;
	}
	return index;
}	
#endif

#ifdef H8_3048
int int_table_3048(int num) {
	int	index;

	index = -1;
	if(num >= 7 && num <= 17) {
		index = num - 7;
	} else if(num >= 20 && num <= 21) {
		index = num - 9;
	} else if(num >= 24 && num <= 26) {
		index = num - 11;
	} else if(num >= 28 && num <= 30) {
		index = num - 12;
	} else if(num >= 32 && num <= 34) {
		index = num - 13;
	} else if(num >= 36 && num <= 38) {
		index = num - 14;
	} else if(num >= 40 && num <= 42) {
		index = num - 15;
	} else if(num >= 44 && num <= 47) {
		index = num - 16;
	} else if(num >= 52 && num <= 60) {
		index = num - 20;
	}
	return index;
}	
#endif

int int_regist(int num, void (*proc)()) {
	int	index;

#ifdef H8_3067
	index = int_table_3067(num);
#endif
#ifdef H8_3048
	index = int_table_3048(num);
#endif
#ifdef H8_3664
	index = int_table_3664(num);
#endif
	if(index == -1) return -1;
	if(int_proc[index] != 0) return -1;
	int_proc[index] = proc;
	return 0;
}

int int_unregist(int num) {
	int	index;

#ifdef H8_3067
	index = int_table_3067(num);
#endif
#ifdef H8_3048
	index = int_table_3048(num);
#endif
#ifdef H8_3664
	index = int_table_3664(num);
#endif
	if(index == -1) return -1;
	if(int_proc[index] == 0) return -1;
	int_proc[index] = 0;
	return 0;
}

#define DownEdge	1
#define UpEdge		2
void	nmi_edge(int edge) {
#ifdef H8_3664	
	if(edge == DownEdge) {
		IEGR1 &= ~0x80;
	} else if(edge == UpEdge) {
		IEGR1 |= 0x80;
	}
#else
	if(edge == DownEdge) {
		SYSCR &= ~0x04;
	} else if(edge == UpEdge) {
		SYSCR |= 0x04;
	}
#endif
}

#pragma interrupt
void int_nmi() {
	if(int_proc[0] != 0) (*int_proc[0])();
}

#pragma interrupt
void int_trap0() {
	if(int_proc[1] != 0) (*int_proc[1])();
}

#pragma interrupt
void int_trap1() {
	if(int_proc[2] != 0) (*int_proc[2])();
}

#pragma interrupt
void int_trap2() {
	if(int_proc[3] != 0) (*int_proc[3])();
}

#pragma interrupt
void int_trap3() {
	if(int_proc[4] != 0) (*int_proc[4])();
}

#ifndef H8_3664

#pragma interrupt
void int_irq0() {
	if(int_proc[5] != 0) (*int_proc[5])();
}

#pragma interrupt
void int_irq1() {
	if(int_proc[6] != 0) (*int_proc[6])();
}

#pragma interrupt
void int_irq2() {
	if(int_proc[7] != 0) (*int_proc[7])();
}

#pragma interrupt
void int_irq3() {
	if(int_proc[8] != 0) (*int_proc[8])();
}

#pragma interrupt
void int_irq4() {
	if(int_proc[9] != 0) (*int_proc[9])();
}

#pragma interrupt
void int_irq5() {
	if(int_proc[10] != 0) (*int_proc[10])();
}

#pragma interrupt
void int_wovi() {
	if(int_proc[11] != 0) (*int_proc[11])();
}

#pragma interrupt
void int_cmi() {
	if(int_proc[12] != 0) (*int_proc[12])();
}

#endif

#ifdef H8_3067

#pragma interrupt
void int_adi() {
	if(int_proc[13] != 0) (*int_proc[13])();
}

#pragma interrupt
void int_imia0() {
	if(int_proc[14] != 0) (*int_proc[14])();
}

#pragma interrupt
void int_imib0() {
	if(int_proc[15] != 0) (*int_proc[15])();
}

#pragma interrupt
void int_ovi0() {
	if(int_proc[16] != 0) (*int_proc[16])();
}

#pragma interrupt
void int_imia1() {
	if(int_proc[17] != 0) (*int_proc[17])();
}

#pragma interrupt
void int_imib1() {
	if(int_proc[18] != 0) (*int_proc[18])();
}

#pragma interrupt
void int_ovi1() {
	if(int_proc[19] != 0) (*int_proc[19])();
}

#pragma interrupt
void int_imia2() {
	if(int_proc[20] != 0) (*int_proc[20])();
}

#pragma interrupt
void int_imib2() {
	if(int_proc[21] != 0) (*int_proc[21])();
}

#pragma interrupt
void int_ovi2() {
	if(int_proc[22] != 0) (*int_proc[22])();
}

#pragma interrupt
void int_cmia0() {
	if(int_proc[23] != 0) (*int_proc[23])();
}

#pragma interrupt
void int_cmib0() {
	if(int_proc[24] != 0) (*int_proc[24])();
}

#pragma interrupt
void int_cmiab1() {
	if(int_proc[25] != 0) (*int_proc[25])();
}

#pragma interrupt
void int_tovi01() {
	if(int_proc[26] != 0) (*int_proc[26])();
}

#pragma interrupt
void int_cmia2() {
	if(int_proc[27] != 0) (*int_proc[27])();
}

#pragma interrupt
void int_cmib2() {
	if(int_proc[28] != 0) (*int_proc[28])();
}

#pragma interrupt
void int_cmiab3() {
	if(int_proc[29] != 0) (*int_proc[29])();
}

#pragma interrupt
void int_tovi23() {
	if(int_proc[30] != 0) (*int_proc[30])();
}

#pragma interrupt
void int_dend0a() {
	if(int_proc[31] != 0) (*int_proc[31])();
}

#pragma interrupt
void int_dend0b() {
	if(int_proc[32] != 0) (*int_proc[32])();
}

#pragma interrupt
void int_dend1a() {
	if(int_proc[33] != 0) (*int_proc[33])();
}

#pragma interrupt
void int_dend1b() {
	if(int_proc[34] != 0) (*int_proc[35])();
}

#pragma interrupt
void int_eri0() {
	if(int_proc[35] != 0) (*int_proc[35])();
}

#pragma interrupt
void int_rxi0() {
	if(int_proc[36] != 0) (*int_proc[36])();
}

#pragma interrupt
void int_txi0() {
	if(int_proc[37] != 0) (*int_proc[37])();
}

#pragma interrupt
void int_tei0() {
	if(int_proc[38] != 0) (*int_proc[38])();
}

#pragma interrupt
void int_eri1() {
	if(int_proc[39] != 0) (*int_proc[39])();
}

#pragma interrupt
void int_rxi1() {
	if(int_proc[40] != 0) (*int_proc[40])();
}

#pragma interrupt
void int_txi1() {
	if(int_proc[41] != 0) (*int_proc[41])();
}

#pragma interrupt
void int_tei1() {
	if(int_proc[42] != 0) (*int_proc[42])();
}

#pragma interrupt
void int_eri2() {
	if(int_proc[43] != 0) (*int_proc[43])();
}

#pragma interrupt
void int_rxi2() {
	if(int_proc[44] != 0) (*int_proc[44])();
}

#pragma interrupt
void int_txi2() {
	if(int_proc[45] != 0) (*int_proc[45])();
}

#pragma interrupt
void int_tei2() {
	if(int_proc[46] != 0) (*int_proc[46])();
}

#endif

#ifdef H8_3048

#pragma interrupt
void int_imia0() {
	if(int_proc[13] != 0) (*int_proc[13])();
}

#pragma interrupt
void int_imib0() {
	if(int_proc[14] != 0) (*int_proc[14])();
}

#pragma interrupt
void int_ovi0() {
	if(int_proc[15] != 0) (*int_proc[15])();
}

#pragma interrupt
void int_imia1() {
	if(int_proc[16] != 0) (*int_proc[16])();
}

#pragma interrupt
void int_imib1() {
	if(int_proc[17] != 0) (*int_proc[17])();
}

#pragma interrupt
void int_ovi1() {
	if(int_proc[18] != 0) (*int_proc[18])();
}

#pragma interrupt
void int_imia2() {
	if(int_proc[19] != 0) (*int_proc[19])();
}

#pragma interrupt
void int_imib2() {
	if(int_proc[20] != 0) (*int_proc[20])();
}

#pragma interrupt
void int_ovi2() {
	if(int_proc[21] != 0) (*int_proc[21])();
}

#pragma interrupt
void int_imia3() {
	if(int_proc[22] != 0) (*int_proc[22])();
}

#pragma interrupt
void int_imib3() {
	if(int_proc[23] != 0) (*int_proc[23])();
}

#pragma interrupt
void int_ovi3() {
	if(int_proc[24] != 0) (*int_proc[24])();
}

#pragma interrupt
void int_imia4() {
	if(int_proc[25] != 0) (*int_proc[25])();
}

#pragma interrupt
void int_imib4() {
	if(int_proc[26] != 0) (*int_proc[26])();
}

#pragma interrupt
void int_ovi4() {
	if(int_proc[27] != 0) (*int_proc[27])();
}

#pragma interrupt
void int_dend0a() {
	if(int_proc[28] != 0) (*int_proc[28])();
}

#pragma interrupt
void int_dend0b() {
 	if(int_proc[29] != 0) (*int_proc[29])();
}

#pragma interrupt
void int_dend1a() {
	if(int_proc[30] != 0) (*int_proc[30])();
}

#pragma interrupt
void int_dend1b() {
	if(int_proc[31] != 0) (*int_proc[31])();
}

#pragma interrupt
void int_eri0() {
	if(int_proc[32] != 0) (*int_proc[32])();
}

#pragma interrupt
void int_rxi0() {
	if(int_proc[33] != 0) (*int_proc[33])();
}

#pragma interrupt
void int_txi0() {
	if(int_proc[34] != 0) (*int_proc[34])();
}

#pragma interrupt
void int_tei0() {
	if(int_proc[35] != 0) (*int_proc[35])();
}

#pragma interrupt
void int_eri1() {
	if(int_proc[36] != 0) (*int_proc[36])();
}

#pragma interrupt
void int_rxi1() {
	if(int_proc[37] != 0) (*int_proc[37])();
}

#pragma interrupt
void int_txi1() {
	if(int_proc[38] != 0) (*int_proc[38])();
}

#pragma interrupt
void int_tei1() {
	if(int_proc[39] != 0) (*int_proc[39])();
}

#pragma interrupt
void int_adi() {
	if(int_proc[40] != 0) (*int_proc[40])();
}

#endif

#ifdef H8_3664

#pragma interrupt
void int_break() {
	if(int_proc[5] != 0) (*int_proc[5])();
}

#pragma interrupt
void int_sleep() {
	if(int_proc[6] != 0) (*int_proc[6])();
}

#pragma interrupt
void int_irq0() {
	if(int_proc[7] != 0) (*int_proc[7])();
}

#pragma interrupt
void int_irq1() {
	if(int_proc[8] != 0) (*int_proc[8])();
}

#pragma interrupt
void int_irq2() {
	if(int_proc[9] != 0) (*int_proc[9])();
}

#pragma interrupt
void int_irq3() {
	if(int_proc[10] != 0) (*int_proc[10])();
}

#pragma interrupt
void int_wkp() {
	if(int_proc[11] != 0) (*int_proc[11])();
}

#pragma interrupt
void int_timera() {
	if(int_proc[12] != 0) (*int_proc[12])();
}

#pragma interrupt
void int_timerw() {
	if(int_proc[13] != 0) (*int_proc[13])();
}

#pragma interrupt
void int_timerv() {
	if(int_proc[14] != 0) (*int_proc[14])();
}

#pragma interrupt
void int_sci3() {
	if(int_proc[15] != 0) (*int_proc[15])();
}

#pragma interrupt
void int_iic() {
	if(int_proc[16] != 0) (*int_proc[16])();
}

#pragma interrupt
void int_adi() {
	if(int_proc[17] != 0) (*int_proc[17])();
}

#endif

void int_init() {
	int	i;

#ifdef H8_3664
	for(i = 0;i < 18;i++) int_proc[i] = 0;
#else
	for(i = 0;i < 47;i++) int_proc[i] = 0;
#endif
}
