#include "tcpip.h"
#include "regdef.h"  // by kishida koji for WDT
int	ether_write(char*, int, int);
int	ether_flush(int);
int	ether_read(char*, int, int);
int	get_ether_status();
char*	get_mac_address();
int	arp();
int	udp(ip_header*);
//int	 tcp(ip_header*);
int	table_init(char*, int);
int	udp_init();
int	tcp_init();
//void tcpIntervalTimer() ; //kishida koji for FIN timer
//void ne_update_BNRY() ; // append by kishida koji (2009.11.29)

char*	ref_mac(int);
extern  struct mac_info	mytable;
extern  unsigned int	gw_ip;
extern  volatile unsigned char	*ne_base_addr;
unsigned int	netmask;
char		ip_enable;
unsigned short	tmp_port;

static unsigned short ip_count;

unsigned short make_crc(char *buffer, int size) {
	unsigned int i, a, b;

	a = 0;
	for(i = 0;i < size;i += 2) {
		b = ((int)buffer[i] & 0xff) * 256;
		b |= (int)buffer[i + 1] & 0xff;
		a = a + b;
		if(a & 0x10000) a++;
		a &= 0xffff;
	}
	return (unsigned short)(~a & 0xffff);
}

unsigned short make_crc2(char *buffer1, int size1, char *buffer2, int size2) {
	unsigned int i, a, b;

	a = 0;
	for(i = 0;i < size1;i += 2) {
		b = ((int)buffer1[i] & 0xff) * 256;
		b |= (int)buffer1[i + 1] & 0xff;
		a = a + b;
		if(a & 0x10000) a++;
		a &= 0xffff;
	}
	for(i = 0;i < size2;i += 2) {
		b = ((int)buffer2[i] & 0xff) * 256;
		b |= (int)buffer2[i + 1] & 0xff;
		a = a + b;
		if(a & 0x10000) a++;
		a &= 0xffff;
	}
	return (unsigned short)(~a & 0xffff);
}

void set_ether_header(char *dest, char *src, unsigned short protocol) {
	ether_header	header;

	memcpy(header.dest, dest, 6);
	memcpy(header.src, src, 6);
	header.protocol = protocol;
	ether_write((char*)(&header), 0, sizeof(ether_header));
}

ip_header* set_ip_header(char protocol, int ip, int header_size, int size, char *opt) {
	static ip_header header;
	char		 *ptr;

	header.version_size = 0x40 + header_size / 4;
	header.tos = 0;
	header.data_size = header_size + size;
	header.number = ip_count++;
	header.offset = 0;
	header.ttl = 64;
	header.protocol = protocol;
	header.checksum = 0;
	memcpy(header.src_ip, (char*)(&mytable.ip), 4);
	memcpy(header.dest_ip, (char*)(&ip), 4);
	memcpy(header.options, opt, 16);
	ptr = (char*)(&header) + sizeof(ether_header);
	header.checksum = make_crc(ptr, header_size);
	ether_write(ptr, sizeof(ether_header), header_size);
	return &header;
}

int icmp(ip_header *ip) {
	unsigned int	src_ip, *p;
	unsigned int	header_size, data_size;
	unsigned short	checksum, checksum_orig;
	ether_header	*ether;
	icmp_echo	echo;
	
	header_size = ((int)ip->version_size & 0xf) * 4;
	data_size = ip->data_size - header_size;
	if(data_size > 255) return -1;       
	ether_read((char*)&echo, sizeof(ether_header) + header_size, data_size);
	checksum_orig = echo.checksum;
	echo.checksum = 0;
	checksum = make_crc((char*)&echo, data_size);
	if(checksum != checksum_orig) return -1;

	p = (int*)ip->src_ip; src_ip = *p;
	ether = (ether_header*)ip->ether_header;
	echo.type = ICMP_ANS;
	echo.code = 0;
	echo.checksum = 0;
	echo.checksum = make_crc((char*)&echo, data_size);
	
	set_ether_header(ether->src, mytable.mac, IP_TYPE);
	set_ip_header(IP_ICMP, src_ip, header_size, data_size, 0);
	ether_write((char*)&echo, sizeof(ether_header) + header_size, data_size);
	ether_flush(sizeof(ether_header) + header_size + data_size);
	return 0;
}

int ip() {
	ip_header	ip;
	unsigned int	src_ip, *p;

//	print("\nip()") ;
	ether_read((char*)&ip, 0, sizeof(ip_header));
		TCNT = 0x5a00 ;
		print("ver&len=%x dsize=%d",ip.version_size,ip.data_size) ;
	p = (int*)ip.src_ip; src_ip = *p;
	if((mytable.ip & netmask) != (src_ip & netmask)) {
		if(gw_ip == 0) return -1;
		else src_ip = gw_ip;
	}
	ref_mac(src_ip);
	switch(ip.protocol) {
	case IP_ICMP:
		print("/ICMP") ;
		icmp(&ip);
		break;
	case IP_UDP:
		print("/UCP") ;
		udp(&ip);
		break;
	case IP_TCP:
		print("/TCP") ;
		tcp(&ip);
		break;
	}
//	print("\n/") ;
	return 0;
}

void ip_interval() {
	int		n;
	ether_header	ether;
	
	if(ip_enable == 0 ) return;	// kishida koji (2009/11/23)
	tcpIntervalTimer() ;	// kishida koji (2009/11/23)
	
//	if(ip_enable == 0 || n < 1) return;   // kishida koji (2009/11/23)
	while( (n = ether_get()) > 0 ) {	  // kishida koji (2009/12/12)
		ether_read((char*)&ether, 0, sizeof(ether_header));
//		print("/ipi1") ;
		switch(ether.protocol) {
		case ARP_TYPE:
			print("rcv ARP") ;
			arp();
//			print("/ipi3") ;
			break;
		case IP_TYPE:
			print("rcv IP") ;	
			ip();
//			print("/ipi5") ;
			break;
		}
//		print("/ipi5/") ;
		ne_update_BNRY() ; // append by kishida koji (2009/11/29)
		print("\nENDi p_int") ;
	};	  // kishida koji (2009/12/12)
}

int get_ipinfo(unsigned int *addr, unsigned int *mask) {
	if(ip_enable) {
		*addr = mytable.ip;
		*mask = netmask;
	} else {
		*addr = 0;
		*mask = 0;
	}
	return ip_enable;
}

int ip_setup(unsigned int addr, unsigned int mask) {
	int	i;
	char	*mac;

	if(get_ether_status() == 0) return -1;
	mac = get_mac_address();
	netmask = mask;
	ip_count = 1;
	tmp_port = 1025;
	table_init(mac, addr);
	tcp_init();
	udp_init();
	ether_setup();
	ip_enable = 1;
	return 0;
}

void ip_init() {
	ip_enable = 0;
}
