#include "ne2000.h"
#include "regdef.h"  // for WDT by kishida.koji (2009.11.3)

volatile unsigned char	*ne_base_addr;
int	neregmul;
char	mac_address[6];
char	ether_enable = 0;
int	data_size;
static int gReceiveStart, gReceiveLength, gRxNextBNRY ;

void ne_writemem(unsigned char *src, unsigned int dest, unsigned int size) {
	int	i;
	char	c;

	NE_P0_COMMAND = NE_CR_RD2 | NE_CR_STA;	/* DMA ߡå׵ǽͭ */
	NE_P0_ISR = 0;				/* ơ쥸ꥢ */
	NE_P0_RBCR0 = size;			/* Хȿ */
	NE_P0_RBCR1 = size >> 8;
	NE_P0_RSAR0 = dest;			/* ž襢ɥ쥹 */
	NE_P0_RSAR1 = dest >> 8;
	NE_P0_COMMAND = NE_CR_RD1 | NE_CR_STA;	/* ⡼å׵ǽͭ */
	for(i = 0;i < size;i++) NE_ASIC_DATA = src[i];	/* ǡž */
	unsigned int counter = 0 ;
	while(!(NE_P0_ISR & NE_ISR_RDC)){
		if( counter  < 30000 ){	// by kishida koji (2009.11.23)
			TCNT = 0x5a00 ;  // by kishida koji (2009.10.29)
			counter ++ ;	// by kishida koji (2009.11.23)
		}			// by kishida koji (2009.11.23)
		else if ( counter  == 30000) {
			print("writemem wait") ;
			counter ++ ;
		};
	};
}

void ne_readmem(unsigned int src, unsigned char *dest, unsigned int size) {
	int	i;

//		print("(ne read") ;
	NE_P0_COMMAND = NE_CR_RD2 | NE_CR_STA;	/* DMA ߡå׵ǽͭ */
	NE_P0_RBCR0 = size;			/* Хȿ */
	NE_P0_RBCR1 = size >> 8;
	NE_P0_RSAR0 = src;			/* žɥ쥹 */
	NE_P0_RSAR1 = src >> 8;
	NE_P0_COMMAND = NE_CR_RD0 | NE_CR_STA;	/* ⡼ȼå׵ǽͭ */
	TCNT = 0x5a00 ;  // by kishida koji (2009.11.23)
//		print("1") ;
	for(i = 0;i < size;i++) dest[i] = NE_ASIC_DATA;	/* ǡž */
//		print("2)") ;
}

#define COPY_BUFSIZ	32
void ne_copymem(unsigned int src, unsigned int dest, int size) {
	int	i, j, n;
	char	buffer[COPY_BUFSIZ];

	for(i = 0;i < size;i += COPY_BUFSIZ) {
		n = ((size - i) >= COPY_BUFSIZ) ?  COPY_BUFSIZ : size - i;
		ne_readmem(src + i, buffer, n);
		ne_writemem(buffer, dest + i, n);
	}
}

int ne2000_probe() {
	int	i, a, size;
	char	test_message[21] = "NE2000 test message.";
	char	test_buffer[21], eeprom[32];
	
	/* եȥꥻå */
	a = NE_ASIC_RESET;
	NE_ASIC_RESET = 0;

	for(a = 0;a < 0x200;a++);	/* Ԥ */
	/* DMA ߡå׵ǽ */
	NE_P0_COMMAND = NE_CR_RD2 | NE_CR_STP;
	for(a = 0;a < 0x200;a++);	/* Ԥ */

	/* ѥåȤ˽񤫤ʤ褦ˤ */
	NE_P0_RCR = NE_RCR_MON;

	/* Хž롼ץХå⡼ */
	NE_P0_DCR = NE_DCR_FT1 | NE_DCR_LS;

	/* Хåեϥɥ쥹 */
	NE_P0_PSTART = NE_MEM_START;

	/* Хåեλɥ쥹 */
	NE_P0_PSTOP = NE_MEM_END;

	/* ХåեRAMΥå */
	ne_writemem(test_message, NE_MEM_START * NE_PAGE_SIZE, 20);
	ne_readmem(NE_MEM_START * NE_PAGE_SIZE, test_buffer, 20);
	test_buffer[20] = 0;
	if(strncmp(test_message, test_buffer, 20) != 0) return -1;

	/* EEPROMɤߤ */
	ne_readmem(0, eeprom, 32);
	for(i = 0;i < 6;i++) mac_address[i] = eeprom[i * 2];

	/* ߥơ쥸ꥢ */
	NE_P0_ISR = 0xff;
	return 0;
}

void ne2000_init() {
	int	i;
	volatile unsigned char *ptr;

	/* ⡼DMA  */
	NE_P0_COMMAND = NE_CR_STP;

	/* FIFO å8Хȡ⡼DMA ưػ */
	/* ӥåǥ8ӥå DMA ž */
	NE_P0_DCR = NE_DCR_BOS | NE_DCR_FT1 | NE_DCR_LS;

	/* ⡼DMA Хȥ󥿥ꥢ */
	NE_P0_RBCR0 = NE_P0_RBCR1 = 0;

	/* ˥⡼(ѥåȼ򤪤ʤХåե󥰤Ϥʤ) */
	NE_P0_RCR = NE_RCR_MON;
	
	/* 롼ץХå⡼ */
	NE_P0_TCR = NE_TCR_LB0;

	/* 󥰥Хåեϥɥ쥹 */
	NE_P0_TPSR = NE_TX_PAGE_START;

	/* 󥰥Хåեϥɥ쥹 */
	NE_P0_PSTART = NE_RX_PAGE_START;

	/* 󥰥Хåեɥ쥹 */
	NE_P0_BNRY = NE_RX_PAGE_START;

	/* 󥰥Хåեλɥ쥹 */
	NE_P0_PSTOP = NE_RX_PAGE_STOP;

	/* ߥơ쥸Υꥢ */
	NE_P0_ISR = 0xff;

	/* ߤȤʤ */
	NE_P0_IMR = 0;

	/* ڡ1 */
	NE_P0_COMMAND = NE_CR_PS1 | NE_CR_STP;

	/* Ethernet ɥ쥹(ǻꤷɥ쥹ΥѥåȤ) */
	NE_P1_PAR0 = mac_address[0];
	NE_P1_PAR1 = mac_address[1];
	NE_P1_PAR2 = mac_address[2];
	NE_P1_PAR3 = mac_address[3];
	NE_P1_PAR4 = mac_address[4];
	NE_P1_PAR5 = mac_address[5];

	/* ǽ˼ѥåȤǼ륢ɥ쥹 */
	NE_P1_CURR = NE_RX_PAGE_START + 1;

	/* ޥ㥹ȥ쥸 */
	NE_P1_MAR0 = 0;
	NE_P1_MAR1 = 0;
	NE_P1_MAR2 = 0;
	NE_P1_MAR3 = 0;
	NE_P1_MAR4 = 0;
	NE_P1_MAR5 = 0;
	NE_P1_MAR6 = 0;
	NE_P1_MAR7 = 0;

	/* ڡ0᤹ */
	NE_P0_COMMAND = NE_CR_STP;

	/* ѥåȥե륿(֥ɥ㥹ȤȼʬΤߤ˳Ǽ) */
	NE_P0_RCR = NE_RCR_AB;

	/* NIC 򥢥ƥ֤ˤ */
	NE_P0_COMMAND = NE_CR_STA;

	/* 롼ץХå⡼ɤȴ̾ư⡼ɤ */
	NE_P0_TCR = 0;
}

int ne2000_write(char *data, int index, int size) {
	int mem_ptr;

	/* 񤭹ΰΥå */
	if(index + size >= NE_PAGE_SIZE * 6) {
		print("ne2000 w-over i=%u s=%u",index,size) ; // kishida koji (2009/11/23) 
		return -1;
	};
	
	/* ⡼ȥХåեΥݥ󥿤 */
	mem_ptr = NE_TX_PAGE_START * NE_PAGE_SIZE;
	mem_ptr += index;

	/* MACɥ쥹⡼ȥХåե˽񤭹 */
	ne_writemem(data, mem_ptr, size);
	return 0;
}

int ne2000_read(char *data, int index, int size) {
	int mem_ptr ;
/* apppend by kishida koji (2009.11.28) */
	mem_ptr = gReceiveStart + index ;
	int ne_rx_sub_len = NE_RX_PAGE_STOP * NE_PAGE_SIZE - gReceiveStart ;
		print("ne read sz=%d adr=%d/",size,mem_ptr) ;
	if( ne_rx_sub_len >= gReceiveLength ) { //󥰥Хåե ޤ֤ʤ
		print("st/") ;
		ne_readmem(mem_ptr, data, size);
	}
	else{ //󥰥Хåե ޤ֤
		print("bk/") ;
		if( ne_rx_sub_len > size ){
			ne_readmem(mem_ptr, data, size);
		}
		else{
			ne_readmem(mem_ptr, data, ne_rx_sub_len);
			mem_ptr = NE_RX_PAGE_START * NE_PAGE_SIZE  ;
			ne_readmem(mem_ptr, data+ne_rx_sub_len,gReceiveLength-ne_rx_sub_len) ;
		} ;
	};
/* end append */

/* STRT comment out by kishida koji (2009.11.28) */
/* 񤭹ΰΥå */
//	if(index + size >= NE_PAGE_SIZE * 6) {
//		print("ne2000 r-over i=%u s=%u",index,size) ;// kishida koji (2009/11/23) 
//		return -1;
//	};
//
//	/* ⡼ȥХåեΥݥ󥿤 */
//	mem_ptr = NE_DATA_PAGE * NE_PAGE_SIZE;
//	mem_ptr += index;
//
//	/* MACɥ쥹⡼ȥХåե˽񤭹 */
//	ne_readmem(mem_ptr, data, size);
/* END comment out by kishida koji */

	return data_size;
}

int ne2000_flush(int sendsize) {	
	int	packetsize;
	int loop ;

	/* λƤ뤫ɤå */
	loop = 0 ; // by kishida koji (2009.10.29)
	while(NE_P0_COMMAND & NE_CR_TXP){
		// by kishida koji (2009.10.29)
		if(loop < 10000) {
			TCNT = 0x5a00 ;  
			loop++ ;
		}else if( loop == 10000){
			print("ne200_flush wait over1") ;
			loop++;
		}
		else{
		};
	};

	/* ѥåȤ礭 */
	packetsize = sendsize;
	if(packetsize < ETHER_MIN_PACKET) packetsize = ETHER_MIN_PACKET;

	/* ޤ򤷤ʤ */
	NE_P0_COMMAND = NE_CR_PS0 | NE_CR_RD2 | NE_CR_STA;

	/* Хåեΰλ */
	NE_P0_TPSR = NE_TX_PAGE_START;

	/* Ĺλ */
	NE_P0_TBCR0 = packetsize;
	NE_P0_TBCR1 = packetsize >> 8;

	/* ̿ȯԤ */
	NE_P0_COMMAND = NE_CR_PS0 | NE_CR_TXP | NE_CR_RD2 | NE_CR_STA;

	/* λƤ뤫ɤå */
	loop = 0 ; // by kishida koji (2009.10.29)
	while(NE_P0_COMMAND & NE_CR_TXP){
		// by kishida koji (2009.10.29)
		if(loop < 10000) {
			TCNT = 0x5a00 ;  
			loop++ ;
		}else if( loop == 10000){
			print("ne200_flush wait over2") ;
			loop++;
		}
		else{
		};
	};

	/* 顼Υå */
	if(NE_P0_TSR & NE_TSR_PTX) return 0;
//	else return -1;		// by kishida koji 2009.8.9
		
//	oslog("ne2000_flush send ERROR\n")  ;			// by kishida koji 2009.8.9
	while(1) ;			// by kishida koji 2009.8.9
	return -1 ;	 	// by kishida koji 2009.8.9
}

int ne2000_input(int memptr) {
	int	rs_stat, int_stat, bound, current, bound_reg;
	int	ne_rx_start, ne_rx_len, ne_rx_bound;
	int	ne_rx_sub_len, ne_rx_remain_len;
	char	ne_ringbuf_status, ne_ring_buffer[4];
	int	readdata;

	readdata = memptr;
	/* ڡ0 */
	NE_P0_COMMAND = NE_CR_STA;
	/* ơΥå */
	/* append by kishida koji (2009.12.06) */
	while( NE_P0_ISR & NE_ISR_OVW){
		print(" OVW ") ;
		ne2000_init() ;
	};
	/* append end */	
	rs_stat = NE_P0_RSR;
	int_stat = NE_P0_ISR;
	if(rs_stat & NE_RSTAT_OVER) return 0;
//	if(int_stat & NE_ISR_OVW) return -1;	// by kishida koji 2009.8.9
	if(int_stat & NE_ISR_OVW) {		// by kishida koji 2009.12.8
			print(" OVW ") ;		// by kishida koji 2009.12.8
			ne2000_init() ;		// by kishida koji 2009.12.8
			return -1 ;			// by kishida koji 2009.12.8
//			while(1) ;	// by kishida koji 2009.8.9
	};				;	// by kishida koji 2009.11.28
	if(!(rs_stat & NE_RSTAT_PRX)) return 0;
	/* ȥڡμ */
	bound = NE_P0_BNRY + 1;
	if(bound >= NE_RX_PAGE_STOP) bound = NE_RX_PAGE_START;
	/* ڡ1 */
	NE_P0_COMMAND = NE_CR_PS1;
	/* ȥڡμ */
	current = NE_P1_CURR;
//	if(current >= NE_RX_PAGE_STOP) current = NE_RX_PAGE_START;
	if(current > NE_RX_PAGE_STOP) current = NE_RX_PAGE_START;  // kishida koji (2009.11.29)
	/* ڡ0 */
	NE_P0_COMMAND = NE_CR_PS0;
	/* ǡ̵ͭΥå */
	if(current == bound) return 0;
	/* ڡƬ4ХȤɤ߹ */
	ne_readmem(bound * NE_PAGE_SIZE, ne_ring_buffer, 4);
	ne_ringbuf_status =  ne_ring_buffer[0];
	/* λζ쥸 */
	ne_rx_bound = ne_ring_buffer[1] & 0xff;
	/* ѥåΤγϥɥ쥹 */
	ne_rx_start = bound * NE_PAGE_SIZE + 4;
	/* ѥåΤĹ */
	ne_rx_len = (ne_ring_buffer[3] & 0xff) * 256;
	ne_rx_len |= ne_ring_buffer[2] & 0xff;
	/* ｪλ */
/* append by kishida koji (2009/11/29) */
		gReceiveStart = ne_rx_start ;
		gReceiveLength = ne_rx_len ;
		gRxNextBNRY = ne_rx_bound ;
	if( ne_ringbuf_status & NE_RSTAT_PRX &&
	    ne_rx_len >= ETHER_HEADER_SIZE && ne_rx_len <= ETHER_MAX_PACKET ) {
		print("\nne ok c=%d s=%d l=%d n=%d\n",current,ne_rx_start,ne_rx_len,ne_rx_bound) ;
		return ne_rx_len;
		}
	else {
		NE_P0_BNRY = (ne_rx_bound == NE_RX_PAGE_START) ? NE_RX_PAGE_STOP : (ne_rx_bound - 1 );
		print("\nne ng c=%d s=%d l=%d n=%d\n",current,ne_rx_start,ne_rx_len,ne_rx_bound) ;
		return 0 ;
	};
		
/* end append */

/* STRT comment out by kishida koji (2009.11.28) */
//	if( ne_ringbuf_status & NE_RSTAT_PRX &&
//	    ne_rx_len >= ETHER_HEADER_SIZE && ne_rx_len <= ETHER_MAX_PACKET ) {
//		ne_rx_remain_len = ne_rx_len;
//		/* ޤ֤ʬĹ */
//		ne_rx_sub_len = NE_RX_PAGE_STOP * NE_PAGE_SIZE - ne_rx_start;
//		/* 󥰥Хåեޤ֤뤫 */
//		if(ne_rx_sub_len < ne_rx_len) {
//			/* ѥåȾɤ߹ */
//			ne_copymem(ne_rx_start, readdata, ne_rx_sub_len);
//			ne_rx_start = NE_RX_PAGE_START * NE_PAGE_SIZE;
//			/* 񤭹ߥɥ쥹ι */
//			readdata += ne_rx_sub_len;
//			/* Ĥɤ߹Ĺι */
//			ne_rx_remain_len = ne_rx_len - ne_rx_sub_len;
//		}
//		/* ѥåȤɤ߹ */
//		ne_copymem(ne_rx_start, readdata, ne_rx_remain_len);
//	} else ne_rx_len = 0;
//	bound_reg = (ne_rx_bound == NE_RX_PAGE_START) ? NE_RX_PAGE_STOP : ne_rx_bound;
//	bound_reg--;
//	NE_P0_BNRY = bound_reg;
//	return ne_rx_len;
/* END comment out by kishida koji */	
}

/* append by kishida koji (2009/11/29) */
void ne_update_BNRY(){
	if(gRxNextBNRY > 0 ){
		NE_P0_BNRY = (gRxNextBNRY == NE_RX_PAGE_START) ? NE_RX_PAGE_STOP : (gRxNextBNRY- 1 );
		print("ne-up ok cu=%d BNRY=%d nx=%d\n",NE_P1_CURR,NE_P0_BNRY,gRxNextBNRY) ;
		gRxNextBNRY = -1 ;
	}
	else{
		NE_P0_BNRY = (NE_P1_CURR == NE_RX_PAGE_START) ? NE_RX_PAGE_STOP : (NE_P1_CURR- 1 );
		print("ne-up NG cu=%d BNRY=%d nx=%d\n",NE_P1_CURR,NE_P0_BNRY,gRxNextBNRY) ;
	}
}
/* end appened  by kishida koji (2009/11/29) */

int ne2000_get() {
	data_size = ne2000_input(NE_DATA_PAGE * NE_PAGE_SIZE);
	return data_size;
}

#define wait() {int i;for(i=0;i<30;i++);}
#define wait_tcs() {int i;for(i=0;i<60;i++);}
#define WEN	0x130
#define WDS	0x100
#define READ	0x180
#define WRITE	0x140
#define WRALL	0x100

int ee_command(int comm) {
	int	mask, port;	

	NE_P3_9346CR = NE_9346CR_EEPROG | NE_9346CR_EECS;
	wait();
	for(mask = 0x100;mask != 0;mask >>= 1) {
		port = ((comm & mask) ? NE_9346CR_EEDI : 0) | NE_9346CR_EECS;
		NE_P3_9346CR = NE_9346CR_EEPROG | port;
		wait();
		NE_P3_9346CR = NE_9346CR_EEPROG | port | NE_9346CR_EESK;
		wait();
	}
}

void ee_write(int addr, int data) {
	int	i, mask, port;
	
	ee_command(WRITE | (addr & 0x3f));
	for(mask = 0x8000;mask != 0;mask >>= 1) {
		port = ((data & mask) ? NE_9346CR_EEDI : 0) | NE_9346CR_EECS;
		NE_P3_9346CR = NE_9346CR_EEPROG | port;
		wait();
		NE_P3_9346CR = NE_9346CR_EEPROG | port | NE_9346CR_EESK;
		wait();
	}
	NE_P3_9346CR = NE_9346CR_EEPROG;
	wait_tcs();
	NE_P3_9346CR = NE_9346CR_EEPROG | NE_9346CR_EECS;
	while(!(NE_P3_9346CR & NE_9346CR_EEDO)){
		TCNT = 0x5a00 ;  // by kishida koji (2009.10.29)
	};
	NE_P3_9346CR = NE_9346CR_EEPROG;
}

void ee_write_all(int data) {
	int	i, mask, port;
	
	ee_command(WRALL);
	for(mask = 0x8000;mask != 0;mask >>= 1) {
		port = ((data & mask) ? NE_9346CR_EEDI : 0) | NE_9346CR_EECS;
		NE_P3_9346CR = NE_9346CR_EEPROG | port;
		wait();
		NE_P3_9346CR = NE_9346CR_EEPROG | port | NE_9346CR_EESK;
		wait();
	}
	NE_P3_9346CR = NE_9346CR_EEPROG;
	wait_tcs();
	NE_P3_9346CR = NE_9346CR_EEPROG | NE_9346CR_EECS;
	while(!(NE_P3_9346CR & NE_9346CR_EEDO)){
		TCNT = 0x5a00 ;  // by kishida koji (2009.10.29)
	};
	NE_P3_9346CR = NE_9346CR_EEPROG;
}

int ee_read(int addr) {
	int	i, data;
	
	data = 0;
	ee_command(READ | (addr & 0x3f));
	for(i = 0;i <= 16;i++) {
		NE_P3_9346CR = NE_9346CR_EEPROG | NE_9346CR_EECS;
		if(NE_P3_9346CR & NE_9346CR_EEDO) data++;
		data <<= 1;
		wait();
		NE_P3_9346CR = NE_9346CR_EEPROG | NE_9346CR_EECS | NE_9346CR_EESK;
		wait();
	}
	NE_P3_9346CR = NE_9346CR_EEPROG;
	wait_tcs();
	return data >> 1;
}

int ne2000_setmac(char *mac) {
	int data[3];
	
	if(ether_enable) {
		data[0] = ((int)mac[1] & 0xff) << 8;
		data[0] += (int)mac[0] & 0xff;
		data[1] = ((int)mac[3] & 0xff) << 8;
		data[1] += (int)mac[2] & 0xff;
		data[2] = ((int)mac[5] & 0xff) << 8;
		data[2] += (int)mac[4] & 0xff;
		ether_enable = 0;
		NE_P0_COMMAND = NE_CR_PS3;
		NE_P3_9346CR = NE_9346CR_EEPROG |  NE_9346CR_EECS;
		wait_tcs();
		wait();
		ee_command(WEN);
		NE_P3_9346CR = NE_9346CR_EEPROG;
		wait_tcs();
		ee_write(2, data[0]);
		ee_write(3, data[1]);
		ee_write(4, data[2]);
		ee_command(WDS);
		NE_P3_9346CR = NE_9346CR_EEPROG;
		wait_tcs();
		NE_P0_COMMAND = NE_CR_PS0;
		ether_enable = 1;
		return 0;
	}
	return -1;
}

int ne2000_getmac(char *mac) {
	int i, data[3];
	
	if(ether_enable) {
		ether_enable = 0;
		NE_P0_COMMAND = NE_CR_PS3;
		NE_P3_9346CR = NE_9346CR_EEPROG |  NE_9346CR_EECS;
		wait();
		for(i = 0;i < 3;i++) data[i] = ee_read(i + 2);
		NE_P0_COMMAND = NE_CR_PS0;
		ether_enable = 1;
		for(i = 0;i < 3;i++) {
			mac[i * 2] = data[i] & 0xff;
			mac[i * 2 + 1] = (data[i] >> 8) & 0xff;
		}
		return 0;
	}
	return -1;
}

int ne_setup() {
	int	i;
	
	ether_enable = 0;
	for(i = 0;i < 6;i++) mac_address[i] = 0xff;
	if(ne2000_probe() == -1) return -1;
	ether_enable = 1;
	return 0;
}

int ne_init() {
	int	i;
	
	ne_base_addr = (volatile unsigned char*)0;
	ether_enable = 0;
	for(i = 0;i < 6;i++) mac_address[i] = 0xff;
}
