#define MULTI	neregmul

#define NE_P0_COMMAND	ne_base_addr[0*MULTI]
#define NE_P0_PSTART	ne_base_addr[1*MULTI]
#define NE_P0_PSTOP	ne_base_addr[2*MULTI]
#define NE_P0_BNRY	ne_base_addr[3*MULTI]	/* Boundary Reg */
#define NE_P0_TSR	ne_base_addr[4*MULTI]	/* Transmit Status Reg */
#define NE_P0_TPSR	ne_base_addr[4*MULTI]	/* Transmit Page Start Address Reg */
#define NE_P0_NCR	ne_base_addr[5*MULTI]	/* Nubmer of Collisions */
#define NE_P0_TBCR0	ne_base_addr[5*MULTI]	/* Transmit Byte Counter Reg */
#define NE_P0_TBCR1	ne_base_addr[6*MULTI]
#define NE_P0_ISR	ne_base_addr[7*MULTI]	/* Interrupt Status Reg */
#define NE_P0_RSAR0	ne_base_addr[8*MULTI]	/* Remote Start Address Reg */
#define NE_P0_RSAR1	ne_base_addr[9*MULTI]
#define NE_P0_RBCR0	ne_base_addr[10*MULTI]	/* Remote Byte Count Reg */
#define NE_P0_RBCR1	ne_base_addr[11*MULTI]
#define NE_P0_RSR	ne_base_addr[12*MULTI]	/* Receive Status Reg */
#define NE_P0_RCR	ne_base_addr[12*MULTI]	/* Receive Configuration Reg */
#define NE_P0_TCR	ne_base_addr[13*MULTI]	/* Transmit Configuration Reg */
#define NE_P0_DCR	ne_base_addr[14*MULTI]	/* Data Configuration Reg */
#define NE_P0_IMR	ne_base_addr[15*MULTI]	/* Interrupt Mask Reg */
#define NE_P0_CNTR0	ne_base_addr[13*MULTI]
#define NE_P0_CNTR1	ne_base_addr[14*MULTI]
#define NE_P0_CNTR2	ne_base_addr[15*MULTI]
#define NE_P1_COMMAND	ne_base_addr[0*MULTI]
#define NE_P1_PAR0	ne_base_addr[1*MULTI]		/* Physical Addres Reg */
#define NE_P1_PAR1	ne_base_addr[2*MULTI]
#define NE_P1_PAR2	ne_base_addr[3*MULTI]
#define NE_P1_PAR3	ne_base_addr[4*MULTI]
#define NE_P1_PAR4	ne_base_addr[5*MULTI]
#define NE_P1_PAR5	ne_base_addr[6*MULTI]
#define NE_P1_CURR	ne_base_addr[7*MULTI]		/* Current Page Reg */
#define NE_P1_MAR0	ne_base_addr[8*MULTI]		/* Multicast Address Reg */
#define NE_P1_MAR1	ne_base_addr[9*MULTI]
#define NE_P1_MAR2	ne_base_addr[10*MULTI]
#define NE_P1_MAR3	ne_base_addr[11*MULTI]
#define NE_P1_MAR4	ne_base_addr[12*MULTI]
#define NE_P1_MAR5	ne_base_addr[13*MULTI]
#define NE_P1_MAR6	ne_base_addr[14*MULTI]
#define NE_P1_MAR7	ne_base_addr[15*MULTI]
#define NE_P3_COMMAND	ne_base_addr[0*MULTI]
#define NE_P3_9346CR	ne_base_addr[1*MULTI]
#define NE_P3_BPAGE	ne_base_addr[2*MULTI]
#define NE_P3_CONFIG0	ne_base_addr[3*MULTI]
#define NE_P3_CONFIG1	ne_base_addr[4*MULTI]
#define NE_P3_CONFIG2	ne_base_addr[5*MULTI]
#define NE_P3_CONFIG3	ne_base_addr[6*MULTI]
#define NE_ASIC_DATA	ne_base_addr[16*MULTI]	/* data port */
#define NE_ASIC_RESET	ne_base_addr[24*MULTI]	/* reset port */

/* NE2000  */
#define	NE_CR_PS0	0x00	/* Page 0 Select   */
#define	NE_CR_PS1	0x40	/* Page 1 Select   */
#define	NE_CR_PS2	0x80	/* Page 2 Select   */
#define	NE_CR_PS3	0xc0	/* Page 3 Select   */
#define	NE_CR_PSMASK	0xc0	/* Page Mask       */
#define	NE_CR_RD0	0x08	/********************** 000:DON'T, 001:read  */
#define	NE_CR_RD1	0x10	/* Remote DMA Control * 010:write, 011:trans */
#define NE_CR_RD2	0x20	/********************** 1xx:disable          */
#define NE_CR_TXP	0x04	/* Transmit packet */
#define NE_CR_STA	0x02	/* start	   */
#define	NE_CR_STP	0x01	/* stop		   */

#define	NE_RCR_SEP	0x01	/* accept error packet */
#define	NE_RCR_AR	0x02	/* accept tiny packet */
#define	NE_RCR_AB	0x04	/* accept broadcast */
#define	NE_RCR_MUL	0x08	/* accept multicast */
#define	NE_RCR_PRO	0x10	/* accept all */
#define	NE_RCR_MON	0x20	/* monitor mode */

#define	NE_DCR_FT0	0x20	/* fifo  */
#define	NE_DCR_FT1	0x40	/* fifo  */
#define	NE_DCR_AR	0x10	/* Auto remote */
#define	NE_DCR_WTS	0x01	/* Word Transfer select */
#define	NE_DCR_BOS	0x02	/* Byte Transfer select */
#define	NE_DCR_LAS	0x04	/* Long Transfer select */
#define	NE_DCR_LS	0x08	/* Loopback select */

#define	NE_ISR_PRX	0x01	/* successful receive */
#define	NE_ISR_PTX	0x02	/* successful trasmit */
#define	NE_ISR_RXE	0x04	/* receive error */
#define	NE_ISR_TXE	0x08	/* transmit error */
#define	NE_ISR_OVW	0x10	/* overflow */
#define	NE_ISR_CNT	0x20	/* counter overflow */
#define	NE_ISR_RDC	0x40	/* Remote DMA complete */
#define	NE_ISR_RST	0x80	/* reset */

#define	NE_IMR_PRXE	0x01	/* successful receive */
#define	NE_IMR_PTXE	0x02	/* successful trasmit */
#define	NE_IMR_RXEE	0x04	/* receive error */
#define	NE_IMR_TXEE	0x08	/* transmit error */
#define	NE_IMR_OVWE	0x10	/* overflow */
#define	NE_IMR_CNTE	0x20	/* counter overflow */
#define	NE_IMR_RDCE	0x40	/* Remote DMA complete */

#define	NE_RSTAT_PRX	0x01	/* successful receive */
#define	NE_RSTAT_CRC	0x02	/* CRC error */
#define	NE_RSTAT_FAE	0x04	/* Frame alignment error */
#define	NE_RSTAT_OVER	0x08	/* overflow */

#define	NE_TSR_PTX	0x01	/* Transmit complete */
#define	NE_TSR_ABT	0x08	/* Transmit Aborted */

#define	NE_TCR_LB0	0x02	/* Internal loopback */
#define	NE_TCR_LB1	0x04	

#define	NE_9346CR_8390DP 0x00	/* 8390DP compatible mode */
#define	NE_9346CR_EELOAD 0x40	/* EEPROM load mode */
#define	NE_9346CR_EEPROG 0x80	/* EEPROM programable mode*/
#define	NE_9346CR_CNFENA 0xc0	/* Config write enable mode */
#define	NE_9346CR_EEMASK 0xc0	/* mode setting mask*/
#define	NE_9346CR_EECS	 0x08	/* 9346 CS */
#define	NE_9346CR_EESK	 0x04	/* 9346 SK */
#define	NE_9346CR_EEDI	 0x02	/* 9346 DI */
#define	NE_9346CR_EEDO	 0x01	/* 9346 DO */
#define	NE_9346CR_9346MASK 0x0f	/* 9346 mask */

/* NE2000 ΰ */
#define	NE_MEM_START	 0x40	/* Хåե곫ϥڡֹ	(ɥ쥹4000h) */
#define	NE_MEM_END	 0x60	/* Хåե꽪λڡֹ (ɥ쥹6000h) */
#define	NE_PAGE_SIZE	 256	/* 1ڡΥХȿ */
#define	NE_TX_PAGE_START 0x40	/* Хåեϥڡֹ */
#define	NE_RX_PAGE_START 0x46	/* Хåեϥڡֹ */
#define	NE_RX_PAGE_STOP  0x5f	/* Хåեλڡֹ */
#define	NE_DATA_PAGE	 0x7a	/* ǡХåեλڡֹ */

/* ͥå */
#define	ETHER_HEADER_SIZE	14	/* إå */
#define	ETHER_MIN_PACKET	64	/* Ǿѥåȥ */
#define	ETHER_MAX_PACKET	1514	/* ѥåȥ */

