static unsigned REGTYPE	ps2bits[3];
static volatile REGTYPE	*regptr;
static unsigned int	ps2data;
#define CLK_OUT	ps2bits[0]
#define DAT_OUT	ps2bits[1]
#define DAT_IN	ps2bits[2]
#define STARTBIT 0x002000
#define NULLBITS 0x801fff
#define ALLBITS  0xffffff
#define SETBITS  0x800000

#define DownEdge	1
#define UpEdge		2
void nmi_edge(int);
void key_init();
void press_key(unsigned char);

void ps2_clock() {
	ps2data >>= 1;	
	if(*regptr & DAT_IN) ps2data |= SETBITS;
	if(!(ps2data & STARTBIT) && (ps2data & NULLBITS) == NULLBITS) {
		ps2data >>= 14;
		press_key(ps2data);
		ps2data = ALLBITS;
	}
}

int ps2_setup(volatile REGTYPE *reg, REGTYPE *bits) {
	int	c;

	key_init();
	nmi_edge(DownEdge);
	memcpy(ps2bits, bits, 3);
	regptr = reg;
	ps2data = ALLBITS;
	int_regist(7, ps2_clock);
	return 0;
}

void ps2_init() {
	regptr = 0;
}
