#define FCCS	(*(volatile char*)(0xfee0b0))
#define FPCS	(*(volatile char*)(0xfee0b1))
#define FECS	(*(volatile char*)(0xfee0b2))
#define FKEY	(*(volatile char*)(0xfee0b4))
#define FMATS	(*(volatile char*)(0xfee0b5))
#define FTDAR	(*(volatile char*)(0xfee0b6))
#define FVACR	(*(volatile char*)(0xfee0b7))
#define FVADRR	(*(volatile char*)(0xfee0b8))
#define FVADRE	(*(volatile char*)(0xfee0b9))
#define FVADRH	(*(volatile char*)(0xfee0ba))
#define FVADRL	(*(volatile char*)(0xfee0bb))

int load_program() {
	volatile char	*sysram;
	char	(*init_flush)(int, int);
	int		i;

	init_flush = (void*)0xffbf40;
	sysram = (volatile char*)0xffbf20;
	sysram[0] = 0xff;
	FTDAR = 3;	/* start addr is 0xffbf20 */
	FKEY = 0xa5;
	FCCS = 1;	/* SCO = 1 */
	asm("nop\nnop\nnop\nnop\n");
	FKEY = 0;
	for(i = 0;i < 800000;i++) if(sysram[0] == 0) break;
	if(i == 800000) return -1;
	asm("orc #128,ccr");
	if((*init_flush)(FREQ * 100, 0) != 0) return -1;
	return 0;
}

int write_flush(char *target, char *source, int size) {
	int	i, mod;
	char	buffer[128], *ptr;
	char	(*write_flush)(char*, char*);

	write_flush = (void*)0xffbf30;
	ptr = (char*)((int)target & ~0x7f);
	mod = (int)target % 128;
	if(size + mod > 128) return -1;
	for(i = 0;i < 128;i++) buffer[i] = ptr[i];
	for(i = 0;i < size;i++) buffer[i + mod] = source[i];
	FPCS = 1; FECS = 0;
	if(load_program() != 0) return -1;
	FKEY = 0x5a;
	if((*write_flush)(buffer, ptr) != 0) return -1;
	FKEY = FPCS = 0;
	asm("andc #127,ccr");
	return 0;
}

int erase_flush(char *address) {
	int	block;
	volatile char *sysram;
	char	(*erase_flush)(int, int);

	erase_flush = (void*)0xffbf30;
	block = ((int)address >> 16) + 8;
	if(block < 9 || block > 15) return -1;
	FPCS = 0; FECS = 1;
	if(load_program() != 0) return -1;
	FKEY = 0x5a;
	if((*erase_flush)(block, 0) != 0) return -1;
	FKEY = FECS = 0;
	asm("andc #127,ccr");
	return 0;
}


