#include "i2c.h"

#define RTC_WRITE	0xa2
#define RTC_READ	0xa3

extern volatile REGTYPE*	i2c_regp[2];
extern volatile REGTYPE*	i2c_ddrp[2];
extern REGTYPE		i2c_bits[2][2];
void	i2c_start(int);
void	i2c_stop(int);
int	i2c_write(int, int);
int	i2c_read(int);
void	i2c_ack(int);
void	i2c_nak(int);
int	i2c_status(int);
int	send_ctrl(int, int);

int rtc_read(int addr) {
	int	data, ret;

	ret = send_ctrl(RTC_WRITE, RTC);
	if(ret == -1) return -1;
	i2c_write(addr, RTC);
	ret = send_ctrl(RTC_READ, RTC);
	if(ret == -1) return -1;
	data = i2c_read(RTC);
	i2c_nak(RTC);
	i2c_stop(RTC);
	return data;
}

int rtc_write(int addr, int data) {
	int	ret;

	ret = send_ctrl(RTC_WRITE, RTC);
	if(ret == -1) return -1;
	ret = i2c_write(addr, RTC);
	ret = i2c_write(data, RTC);
	i2c_stop(RTC);
	return 0;
}

int rtc_setup(volatile REGTYPE *drreg, volatile REGTYPE *ddrreg, REGTYPE *bits) {
	int	device, size;

	device = RTC;
	i2c_bits[0][device] = bits[0];
	i2c_bits[1][device] = bits[1];
	i2c_ddrp[device] = ddrreg;
	i2c_regp[device] = drreg;
	I2CDDR &= ~SDA;
	I2CDDR |= SCL;
	I2CDR &= ~SCL;
	return size;
}
