OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
ENTRY("_start")
MEMORY
{
	vectors(r) : o = 0x00000000, l = 0x00400
	syscall(r) : o = 0x00000400, l = 0x00200
	rom(rx)    : o = 0x00000600, l = 0x0a000
	user(r)    : o = 0x0000a000, l = 0x06000
	ram(rwx)   : o = 0xffffe800, l = 0x00680
	stack(rw)  : o = 0xfffffc00, l = 0x00400
}
SECTIONS 				
{ 					
.vector1 0x000 : {
	LONG(ABSOLUTE(_start))		/*  0 Reset vector */
	LONG(ABSOLUTE(_stack))		/*    Reserved */
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_stack))
	LONG(DEFINED(_int_geninst)?ABSOLUTE(_int_geninst):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_slotinst)?ABSOLUTE(_int_slotinst):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_cpuaddr)?ABSOLUTE(_int_cpuaddr):ABSOLUTE(_start))
	LONG(DEFINED(_int_dmaaddr)?ABSOLUTE(_int_dmaaddr):ABSOLUTE(_start))
	LONG(DEFINED(_int_nmi)?ABSOLUTE(_int_nmi):ABSOLUTE(_start))
	LONG(DEFINED(_int_userbreak)?ABSOLUTE(_int_usrbreak):ABSOLUTE(_start))
	FILL(0xff)
	} > vectors
.vector2 0x080 : {
	LONG(DEFINED(_int_trap0)?ABSOLUTE(_int_trap0):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap1)?ABSOLUTE(_int_trap1):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap2)?ABSOLUTE(_int_trap2):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap3)?ABSOLUTE(_int_trap3):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap4)?ABSOLUTE(_int_trap4):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap5)?ABSOLUTE(_int_trap5):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap6)?ABSOLUTE(_int_trap6):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap7)?ABSOLUTE(_int_trap7):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap8)?ABSOLUTE(_int_trap8):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap9)?ABSOLUTE(_int_trap9):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap10)?ABSOLUTE(_int_trap10):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap11)?ABSOLUTE(_int_trap11):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap12)?ABSOLUTE(_int_trap12):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap13)?ABSOLUTE(_int_trap13):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap14)?ABSOLUTE(_int_trap14):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap15)?ABSOLUTE(_int_trap15):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap16)?ABSOLUTE(_int_trap16):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap17)?ABSOLUTE(_int_trap17):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap18)?ABSOLUTE(_int_trap18):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap19)?ABSOLUTE(_int_trap19):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap20)?ABSOLUTE(_int_trap20):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap21)?ABSOLUTE(_int_trap21):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap22)?ABSOLUTE(_int_trap22):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap23)?ABSOLUTE(_int_trap23):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap24)?ABSOLUTE(_int_trap24):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap25)?ABSOLUTE(_int_trap25):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap26)?ABSOLUTE(_int_trap26):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap27)?ABSOLUTE(_int_trap27):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap28)?ABSOLUTE(_int_trap28):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap29)?ABSOLUTE(_int_trap29):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap30)?ABSOLUTE(_int_trap30):ABSOLUTE(_start))
	LONG(DEFINED(_int_trap31)?ABSOLUTE(_int_trap31):ABSOLUTE(_start))
	} > vectors
.vector3 0x100 : {
	LONG(DEFINED(_int_irq0)?ABSOLUTE(_int_irq0):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq1)?ABSOLUTE(_int_irq1):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq2)?ABSOLUTE(_int_irq2):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq3)?ABSOLUTE(_int_irq3):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq4)?ABSOLUTE(_int_irq4):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq5)?ABSOLUTE(_int_irq5):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq6)?ABSOLUTE(_int_irq6):ABSOLUTE(_start))
	LONG(DEFINED(_int_irq7)?ABSOLUTE(_int_irq7):ABSOLUTE(_start))
	LONG(DEFINED(_int_dei0)?ABSOLUTE(_int_dei0):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_dei1)?ABSOLUTE(_int_dei1):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_dei2)?ABSOLUTE(_int_dei2):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_dei3)?ABSOLUTE(_int_dei3):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_itv)?ABSOLUTE(_int_itv):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_ici0a)?ABSOLUTE(_int_ici0a):ABSOLUTE(_start))
	LONG(DEFINED(_int_ici0b)?ABSOLUTE(_int_ici0b):ABSOLUTE(_start))
	LONG(DEFINED(_int_ici0c)?ABSOLUTE(_int_ici0c):ABSOLUTE(_start))
	LONG(DEFINED(_int_ici0d)?ABSOLUTE(_int_ici0d):ABSOLUTE(_start))
	LONG(DEFINED(_int_ovio)?ABSOLUTE(_int_ovio):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1a)?ABSOLUTE(_int_imi1a):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1b)?ABSOLUTE(_int_imi1b):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1c)?ABSOLUTE(_int_imi1c):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1d)?ABSOLUTE(_int_imi1d):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1e)?ABSOLUTE(_int_imi1e):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi1f)?ABSOLUTE(_int_imi1f):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_ovi1)?ABSOLUTE(_int_ovi1):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi2a)?ABSOLUTE(_int_imi2a):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi2b)?ABSOLUTE(_int_imi2b):ABSOLUTE(_start))
	LONG(DEFINED(_int_ovi2)?ABSOLUTE(_int_ovi2):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi3a)?ABSOLUTE(_int_imi3a):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi3b)?ABSOLUTE(_int_imi3b):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi3c)?ABSOLUTE(_int_imi3c):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi3d)?ABSOLUTE(_int_imi3d):ABSOLUTE(_start))
	LONG(DEFINED(_int_ovi3)?ABSOLUTE(_int_ovi3):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi4a)?ABSOLUTE(_int_imi4a):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi4b)?ABSOLUTE(_int_imi4b):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi4c)?ABSOLUTE(_int_imi4c):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi4d)?ABSOLUTE(_int_imi4d):ABSOLUTE(_start))
	LONG(DEFINED(_int_ovi4)?ABSOLUTE(_int_ovi4):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_imi5a)?ABSOLUTE(_int_imi5a):ABSOLUTE(_start))
	LONG(DEFINED(_int_imi5b)?ABSOLUTE(_int_imi5b):ABSOLUTE(_start))
	LONG(DEFINED(_int_ovi5)?ABSOLUTE(_int_ovi4):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_cmi6)?ABSOLUTE(_int_cmi6):ABSOLUTE(_start))
	LONG(DEFINED(_int_cmi7)?ABSOLUTE(_int_cmi7):ABSOLUTE(_start))
	LONG(DEFINED(_int_cmi8)?ABSOLUTE(_int_cmi8):ABSOLUTE(_start))
	LONG(DEFINED(_int_cmi9)?ABSOLUTE(_int_cmi9):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10a)?ABSOLUTE(_int_osi10a):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10b)?ABSOLUTE(_int_osi10b):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10c)?ABSOLUTE(_int_osi10c):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10d)?ABSOLUTE(_int_osi10d):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10e)?ABSOLUTE(_int_osi10e):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10f)?ABSOLUTE(_int_osi10f):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10g)?ABSOLUTE(_int_osi10g):ABSOLUTE(_start))
	LONG(DEFINED(_int_osi10h)?ABSOLUTE(_int_osi10h):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_cmti0)?ABSOLUTE(_int_cmti0):ABSOLUTE(_start))
	LONG(DEFINED(_int_adi0)?ABSOLUTE(_int_adi0):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_cmti1)?ABSOLUTE(_int_cmti1):ABSOLUTE(_start))
	LONG(DEFINED(_int_adi1)?ABSOLUTE(_int_adi1):ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(DEFINED(_int_eri0)?ABSOLUTE(_int_eri0):ABSOLUTE(_start))
	LONG(DEFINED(_int_rxi0)?ABSOLUTE(_int_rxi0):ABSOLUTE(_start))
	LONG(DEFINED(_int_txi0)?ABSOLUTE(_int_txi0):ABSOLUTE(_start))
	LONG(DEFINED(_int_tei0)?ABSOLUTE(_int_tei0):ABSOLUTE(_start))
	LONG(DEFINED(_int_eri1)?ABSOLUTE(_int_eri1):ABSOLUTE(_start))
	LONG(DEFINED(_int_rxi1)?ABSOLUTE(_int_rxi1):ABSOLUTE(_start))
	LONG(DEFINED(_int_txi1)?ABSOLUTE(_int_txi1):ABSOLUTE(_start))
	LONG(DEFINED(_int_tei1)?ABSOLUTE(_int_tei1):ABSOLUTE(_start))
	LONG(DEFINED(_int_eri2)?ABSOLUTE(_int_eri2):ABSOLUTE(_start))
	LONG(DEFINED(_int_rxi2)?ABSOLUTE(_int_rxi2):ABSOLUTE(_start))
	LONG(DEFINED(_int_txi2)?ABSOLUTE(_int_txi2):ABSOLUTE(_start))
	LONG(DEFINED(_int_tei2)?ABSOLUTE(_int_tei2):ABSOLUTE(_start))
	LONG(DEFINED(_int_iti)?ABSOLUTE(_int_iti):ABSOLUTE(_start))
	FILL(0xff)
        }  > vectors
.syscall : {
	LONG(DEFINED(_sys_write)?ABSOLUTE(_sys_write):ABSOLUTE(_nop))
	LONG(DEFINED(_write_string)?ABSOLUTE(_write_string):ABSOLUTE(_nop))
	LONG(DEFINED(_write_mode)?ABSOLUTE(_write_mode):ABSOLUTE(_nop))
	LONG(DEFINED(_sys_read)?ABSOLUTE(_sys_read):ABSOLUTE(_nop))
	LONG(DEFINED(_read_string)?ABSOLUTE(_read_string):ABSOLUTE(_nop))
	LONG(DEFINED(_sio_speed)?ABSOLUTE(_sio_speed):ABSOLUTE(_nop))
	LONG(DEFINED(_atohex)?ABSOLUTE(_atohex):ABSOLUTE(_nop))
	LONG(DEFINED(_lcd_clear)?ABSOLUTE(_lcd_clear):ABSOLUTE(_nop))
	LONG(DEFINED(_lcdsetup)?ABSOLUTE(_lcdsetup):ABSOLUTE(_nop))
	LONG(DEFINED(_timer1_regist)?ABSOLUTE(_timer1_regist):ABSOLUTE(_nop))
	LONG(DEFINED(_timer1_unregist)?ABSOLUTE(_timer1_unregist):ABSOLUTE(_nop))
	LONG(DEFINED(_timer2_regist)?ABSOLUTE(_timer2_regist):ABSOLUTE(_nop))
	LONG(DEFINED(_timer2_unregist)?ABSOLUTE(_timer2_unregist):ABSOLUTE(_nop))
	LONG(DEFINED(_timer3_regist)?ABSOLUTE(_timer3_regist):ABSOLUTE(_nop))
	LONG(DEFINED(_timer3_unregist)?ABSOLUTE(_timer3_unregist):ABSOLUTE(_nop))
	LONG(DEFINED(_sleep)?ABSOLUTE(_sleep):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_write)?ABSOLUTE(_ether_write):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_flush)?ABSOLUTE(_ether_flush):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_read)?ABSOLUTE(_ether_read):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_setup)?ABSOLUTE(_ether_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_get)?ABSOLUTE(_ether_get):ABSOLUTE(_nop))
	LONG(DEFINED(_get_ether_status)?ABSOLUTE(_get_ether_status):ABSOLUTE(_nop))
	LONG(DEFINED(_get_mac_address)?ABSOLUTE(_get_mac_address):ABSOLUTE(_nop))
	LONG(DEFINED(_ip_setup)?ABSOLUTE(_ip_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_query_mac)?ABSOLUTE(_query_mac):ABSOLUTE(_nop))
	LONG(DEFINED(_write_decimal)?ABSOLUTE(_write_decimal):ABSOLUTE(_nop))
	LONG(DEFINED(_atodec)?ABSOLUTE(_atodec):ABSOLUTE(_nop))
	LONG(DEFINED(_get_ipinfo)?ABSOLUTE(_get_ipinfo):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_setmac)?ABSOLUTE(_ether_setmac):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_getmac)?ABSOLUTE(_ether_getmac):ABSOLUTE(_nop))
	LONG(DEFINED(_udp_regport)?ABSOLUTE(_udp_regport):ABSOLUTE(_nop))
	LONG(DEFINED(_udp_unregport)?ABSOLUTE(_udp_unregport):ABSOLUTE(_nop))
	LONG(DEFINED(_udp_read)?ABSOLUTE(_udp_read):ABSOLUTE(_nop))
	LONG(DEFINED(_udp_write)?ABSOLUTE(_udp_write):ABSOLUTE(_nop))
	LONG(DEFINED(_save_regport)?ABSOLUTE(_save_regport):ABSOLUTE(_nop))
	LONG(DEFINED(_recover_regport)?ABSOLUTE(_recover_regport):ABSOLUTE(_nop))
	LONG(DEFINED(_set_udpaddr)?ABSOLUTE(_set_udpaddr):ABSOLUTE(_nop))
	LONG(DEFINED(_tcpsocket)?ABSOLUTE(_tcpsocket):ABSOLUTE(_nop))
	LONG(DEFINED(_tcp_regport)?ABSOLUTE(_tcp_regport):ABSOLUTE(_nop))
	LONG(DEFINED(_tcp_unregport)?ABSOLUTE(_tcp_unregport):ABSOLUTE(_nop))
	LONG(DEFINED(_set_tcpaddr)?ABSOLUTE(_set_tcpaddr):ABSOLUTE(_nop))
	LONG(DEFINED(_tcp_read)?ABSOLUTE(_tcp_read):ABSOLUTE(_nop))
	LONG(DEFINED(_tcp_write)?ABSOLUTE(_tcp_write):ABSOLUTE(_nop))
	LONG(DEFINED(_tcp_status)?ABSOLUTE(_tcp_status):ABSOLUTE(_nop))
	LONG(DEFINED(_tcpclose)?ABSOLUTE(_tcpclose):ABSOLUTE(_nop))
	LONG(DEFINED(_ether_init)?ABSOLUTE(_ether_init):ABSOLUTE(_nop))
	LONG(DEFINED(_ata_setup)?ABSOLUTE(_ata_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_int_regist)?ABSOLUTE(_int_regist):ABSOLUTE(_nop))
	LONG(DEFINED(_int_unregist)?ABSOLUTE(_int_unregist):ABSOLUTE(_nop))
	LONG(DEFINED(_ata_sel_drive)?ABSOLUTE(_ata_sel_drive):ABSOLUTE(_nop))
	LONG(DEFINED(_ata_reset)?ABSOLUTE(_ata_reset):ABSOLUTE(_nop))
	LONG(DEFINED(_non_data_command)?ABSOLUTE(_non_data_command):ABSOLUTE(_nop))
	LONG(DEFINED(_ata_identify)?ABSOLUTE(_ata_identify):ABSOLUTE(_nop))
	LONG(DEFINED(_data_in_command)?ABSOLUTE(_data_in_command):ABSOLUTE(_nop))
	LONG(DEFINED(_ata_driveinfo)?ABSOLUTE(_ata_driveinfo):ABSOLUTE(_nop))
	LONG(DEFINED(_data_out_command)?ABSOLUTE(_data_out_command):ABSOLUTE(_nop))
	LONG(DEFINED(_get_hddsize)?ABSOLUTE(_get_hddsize):ABSOLUTE(_nop))
	LONG(DEFINED(_set_gateway)?ABSOLUTE(_set_gateway):ABSOLUTE(_nop))
	LONG(DEFINED(_ps2_setup)?ABSOLUTE(_ps2_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_key_read)?ABSOLUTE(_key_read):ABSOLUTE(_nop))
	LONG(DEFINED(_nmi_edge)?ABSOLUTE(_nmi_edge):ABSOLUTE(_nop))
	LONG(DEFINED(_read_mode)?ABSOLUTE(_read_mode):ABSOLUTE(_nop))
	LONG(DEFINED(_eep_setup)?ABSOLUTE(_eep_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_eep_write)?ABSOLUTE(_eep_write):ABSOLUTE(_nop))
	LONG(DEFINED(_eep_read)?ABSOLUTE(_eep_read):ABSOLUTE(_nop))
	LONG(DEFINED(_dirent_init)?ABSOLUTE(_dirent_init):ABSOLUTE(_nop))
	LONG(DEFINED(_dirent_get)?ABSOLUTE(_dirent_get):ABSOLUTE(_nop))
	LONG(DEFINED(_makedir)?ABSOLUTE(_makedir):ABSOLUTE(_nop))
	LONG(DEFINED(_openfile)?ABSOLUTE(_openfile):ABSOLUTE(_nop))
	LONG(DEFINED(_readfile)?ABSOLUTE(_readfile):ABSOLUTE(_nop))
	LONG(DEFINED(_writefile)?ABSOLUTE(_writefile):ABSOLUTE(_nop))
	LONG(DEFINED(_closefile)?ABSOLUTE(_closefile):ABSOLUTE(_nop))
	LONG(DEFINED(_delete)?ABSOLUTE(_delete):ABSOLUTE(_nop))
	LONG(DEFINED(_renfile)?ABSOLUTE(_renfile):ABSOLUTE(_nop))
	LONG(DEFINED(_get_file_size)?ABSOLUTE(_get_file_size):ABSOLUTE(_nop))
	LONG(DEFINED(_format)?ABSOLUTE(_format):ABSOLUTE(_nop))
	LONG(DEFINED(_nop)?ABSOLUTE(_nop):ABSOLUTE(_nop))
	LONG(DEFINED(_nop)?ABSOLUTE(_nop):ABSOLUTE(_nop))
	LONG(DEFINED(_nop)?ABSOLUTE(_nop):ABSOLUTE(_nop))
	LONG(DEFINED(_print)?ABSOLUTE(_print):ABSOLUTE(_nop))
	LONG(DEFINED(_sprint)?ABSOLUTE(_sprint):ABSOLUTE(_nop))
	LONG(DEFINED(_scan)?ABSOLUTE(_scan):ABSOLUTE(_nop))
	LONG(DEFINED(_sscan)?ABSOLUTE(_sscan):ABSOLUTE(_nop))
	LONG(DEFINED(_bussize_setup)?ABSOLUTE(_bussize_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_cs_setup)?ABSOLUTE(_cs_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_rtc_setup)?ABSOLUTE(_rtc_setup):ABSOLUTE(_nop))
	LONG(DEFINED(_rtc_read)?ABSOLUTE(_rtc_read):ABSOLUTE(_nop))
	LONG(DEFINED(_rtc_write)?ABSOLUTE(_rtc_write):ABSOLUTE(_nop))
	LONG(DEFINED(_memoffset)?ABSOLUTE(_memoffset):ABSOLUTE(_nop))
	LONG(DEFINED(_sio_change)?ABSOLUTE(_sio_change):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_max)?ABSOLUTE(_easy_max):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_dir)?ABSOLUTE(_easy_dir):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_format)?ABSOLUTE(_easy_format):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_find)?ABSOLUTE(_easy_find):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_del)?ABSOLUTE(_easy_del):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_create)?ABSOLUTE(_easy_create):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_write)?ABSOLUTE(_easy_write):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_read)?ABSOLUTE(_easy_read):ABSOLUTE(_nop))
	LONG(DEFINED(_easy_exec)?ABSOLUTE(_easy_exec):ABSOLUTE(_nop))
	LONG(DEFINED(_get_eepsize)?ABSOLUTE(_get_eepsize):ABSOLUTE(_nop))
	LONG(DEFINED(_putch)?ABSOLUTE(_putch):ABSOLUTE(_nop))
	LONG(DEFINED(_getch)?ABSOLUTE(_getch):ABSOLUTE(_nop))
	FILL(0xff)
        }  > syscall
.text : {
	*(.text)
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	 _edata = .;
	} > ram
.bss : {
	 _bss_start = . ;
	*(.bss)
	 _end = . ;  
	}  >ram
.user : {
	_user_start = . ;
	} > user
.stack 0xfffffffc : {
	 _stack = . ;
	}  > stack
}

