#include "tcpip.h"
#include "regdef.h"  // by kishida koji for WDT

int	ether_write(char*, int, int);
int	ether_flush(int);
int	ether_read(char*, int, int);
int	get_ether_status();
char*	query_mac(int);
ip_header* set_ip_header(char, int, int, int, char);
void	set_ether_header(char*, char*, unsigned short);
unsigned short make_crc(char*, int);
unsigned short make_crc2(char*, int, char*, int);
int sockid_alloter ;

#ifdef LARGE
  #define MAX_CONN	48
  #define MAX_TCPPROC	16
#else
  #define MAX_CONN	16
  #define MAX_TCPPROC	8
#endif

tcpinfo	connects[MAX_CONN];
int	(*tcpproc[MAX_TCPPROC])(unsigned short, struct sockaddr_in*, unsigned char, int);
int	(*tcprecv[MAX_TCPPROC])(int flag, int id, struct sockaddr_in*);
static	tcp_data_offset, tcp_data_size;
static  struct sockaddr_in	active_destaddr;
static  unsigned short		active_destport;
static  struct sockaddr_in	passive_destaddr;
static  unsigned short		passive_destport;
static  unsigned char		tcpwrite, cur_id;
extern struct mac_info	mytable;
extern unsigned short	tmp_port;
extern char*		query_mac(int);
extern unsigned char	sock_flag[];
extern char		ip_enable;
extern volatile int	sequence;

int set_tcp_header(char flag, unsigned short src, unsigned short bind, tcpinfo *info, ip_header *ip, char *data) {
	tcp_header	tcp;
	unsigned char	crcbuf[12 + 28];
	unsigned short	crc, tcp_size;
	unsigned int	ip_header_size, tcp_header_size;

	ip_header_size = ((int)ip->version_size & 0xf) * 4;
	tcp_header_size = (flag & SYN) ? 28 : 20;
	tcp_size = ip->data_size - ip_header_size;

	if(bind == 0) tcp.src_port = tmp_port++;
	else tcp.src_port = bind;
	tcp.dest_port = src;
	tcp.src_seq = info->myseq;
	tcp.dest_seq = info->rmseq;
	tcp.header_size = tcp_header_size << 2;
	tcp.flag = flag;
	tcp.winsize = ETHER_MAX_PACKET;
	tcp.checksum = 0;
	tcp.dataptr = 0;
	tcp.type = 2;
	tcp.size = 4;
	tcp.option = ETHER_MAX_PACKET;
	tcp.option2 = 0x01010402;
	memcpy(crcbuf, ip->src_ip, 4);
	memcpy(crcbuf + 4, ip->dest_ip, 4);
	crcbuf[8] = 0;
	crcbuf[9] = IP_TCP;
	memcpy(crcbuf + 10, (char*)&tcp_size, 2);
	memcpy(crcbuf + 12, (char*)&tcp, tcp_header_size);
	if(data == 0)
		crc = make_crc(crcbuf, 12 + tcp_header_size);
	else
		crc = make_crc2(crcbuf, 12 + tcp_header_size, data, tcp_size - tcp_header_size);
	tcp.checksum = crc;
	ether_write((char*)&tcp, sizeof(ether_header) + ip_header_size, tcp_header_size);
}

/* append by kishida koji (2009.11.21) */
int tcp_write_sub(char flag, tcpinfo *tip , char *data, int data_size) {
	char		*mac;
	ip_header	*ip;
//	tcpinfo		*tip;

	if(ip_enable == 0) return -1;
	if((mac = query_mac(tip->destaddr.sin_addr)) == 0) return -1;
	print("TW s=%u a=%u",tip->myseq,tip->rmseq) ;
	print("tws mac=%x:%x:%x:%x:%x:%x ",*mac,*mac+1,*mac+2,*mac+3,*mac+4,*mac+5) ;

	set_ether_header(mac, mytable.mac, IP_TYPE);
	TCNT = 0x5a00 ;  
	unsigned int ip_header_size = 20 ; 
	unsigned int tcp_header_size = (flag & SYN) ? 28 : 20;
	ip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, ip_header_size, tcp_header_size + data_size, 0);
	TCNT = 0x5a00 ;  
	set_tcp_header(flag, tip->destaddr.sin_port, tip->destport, tip, ip, data);
	TCNT = 0x5a00 ;  
	if(data_size > 0 ){
		ether_write(data, sizeof(ether_header) +  ip_header_size + tcp_header_size, data_size);
		TCNT = 0x5a00 ;  
	};
	ether_flush(sizeof(ether_header) + ip_header_size + tcp_header_size + data_size);
	TCNT = 0x5a00 ;  
	return data_size;
}
/* end append */

int tcpsocket(int seq, int (*proc)(int, int, struct sockaddr_in*)) {
	char	*mac;
	char	status;
	char	flag;
	ip_header *myip;
	int	i, index;
	tcpinfo	*tip;

	TCNT = 0x5a00 ;  // by kishida koji
/*	if((mac = query_mac(destaddr.sin_addr)) == 0) return -1;	2003/03/07 delete */
	index = -1;
	for(i = 0;i < MAX_TCPPROC;i++) {
		if(tcprecv[i] == proc) {
			index = i;
			break;
		}
	}
	if(index == -1) {
		for(i = 0;i < MAX_TCPPROC;i++) {
			if(tcprecv[i] == 0) {
				tcprecv[i] = proc;
				index = i;
				break;
			}
		}
	}
	if(index == -1) return -1;
/* append alloter by kishiad koij (2009/11/21) */
	sockid_alloter = sockid_alloter % MAX_CONN ;
	int sockid = -1 ;
	for(i = sockid_alloter;i < MAX_CONN;i++) {
		if(connects[i].status == 0 ) {
			sockid = i ;
			break ;
		};
	} ;
	if( sockid == -1) {
		for(i = 0;i < sockid_alloter;i++) {
			if(connects[i].status == 0 ) {
				sockid = i ;
				break ;
			};
		} ;
	};
	if( sockid < 0 ) return -1 ;
 	sockid_alloter = sockid+1 ;
/* append alloter end */
//	for(i = 0;i < MAX_CONN;i++) {  // for alloter by kishida koij (2009/11/21) 
		TCNT = 0x5a00 ;  // by kishida koji
/* 2003/03/07 change start */
//		tip = &connects[i];			// for alloter by kishida koij (2009/11/21)
		tip = &connects[sockid];	// for alloter by kishida koij (2009/11/21)
//		if(tip->status != 0) continue;	// for alloter by kishida koij (2009/11/21)
		if(seq == 0) {
			if((mac = query_mac(active_destaddr.sin_addr)) == 0) return -1;
					print("ts1 mac=%x:%x:%x:%x:%x:%x ",*mac,*mac+1,*mac+2,*mac+3,*mac+4,*mac+5) ;
			tip->fActive = 1;
			tip->rmseq = 0;
			tip->status = TCP_LISTEN;
			tip->destaddr = active_destaddr;
			tip->destport = active_destport;
			flag = SYN;
		} else {
			if((mac = query_mac(passive_destaddr.sin_addr)) == 0) return -1;
				print("ts2 mac=%x:%x:%x:%x:%x:%x ",*mac,*mac+1,*mac+2,*mac+3,*mac+4,*mac+5) ;
			tip->fActive = 0;
			tip->rmseq = seq + 1;
			tip->status = TCP_SYNRCVD;
			tip->destaddr = passive_destaddr;
			tip->destport = passive_destport;
			flag = SYN | ACK;
		}
		tip->myseq = sequence;
		tip->time = -1;
		tip->index = index;
		tip->timer_remain_msec = 3600 * 1000 ;
		tcp_write_sub(flag,tip,0,0) ;	// by kishida koji (2009.11.23)
//		set_ether_header(mac, mytable.mac, IP_TYPE);
//		TCNT = 0x5a00 ;  // by kishida koji
//		myip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, 20, 28, 0);
//		TCNT = 0x5a00 ;  // by kishida koji
//		set_tcp_header(flag, tip->destaddr.sin_port, tip->destport, tip, myip, 0);
//		TCNT = 0x5a00 ;  // by kishida koji
//		ether_flush(sizeof(ether_header) + 20 + 28);
//		TCNT = 0x5a00 ;  // by kishida koji
		return i;
/* 2003/03/07 change end */
//	} // for alloter by kishida koij (2009/11/21)
//	return -1; // for alloter by kishida koij (2009/11/21)
}

int tcp_status(int id) {
	if(id >= MAX_CONN) return -1;
	return (connects[id].status & 0xff);
}

int tcpfree(int id) {
	int	i, index, flag;
	tcpinfo	*tip;

	print("OS tcpfree(%d)\n",id) ;
	if(id >= MAX_CONN) return -1;
/* 2003/03/07 change start */
	tip = &connects[id];
	index = tip->index;
	tip->status = 0;
	tip->index = 0;
	tip->rmseq = 0;
	tip->destaddr.sin_addr = 0;
	tip->destaddr.sin_port = 0;
	tip->destport = 0;
/* 2003/03/07 change end */
	flag = 0;
	for(i = 0;i < MAX_CONN;i++) {
		if(connects[i].index == index) flag = 1;
	}
	if(flag == 0) tcprecv[index] = 0;
	return 0;
}

int tcpclose(int id) {
	char		*mac;
	char		flag;
	ip_header	*ip;
	tcpinfo		*tip;

/* 2003/03/07 change start */
	if(ip_enable == 0) return -1;
	tip = &connects[id];
//	if(tip->status == 0 || tip->status == TCP_CLOSING) return 0;  // by kishida koji (2009/11/21)
	if(tip->status == 0) return 0; 	// by kishida koji (2009/11/21)
	if((mac = query_mac(tip->destaddr.sin_addr)) == 0) return -1;
		print("tc mac=%x:%x:%x:%x:%x:%x ",*mac,*(mac+1),*(mac+2),*(mac+3),*(mac+4),*(mac+5)) ;
	flag = FIN;
//	if(tip->fActive == 0) flag = ACK | FIN;  // by kishida koji (2009/11/21)
//	tip->status = TCP_FINWAIT1;  // by kishida koji (2009/11/21)
	/* append by kishida koji (2009/12/5) */
	switch (tip->status) {
	case  TCP_ESTAB :
		tip->timer_counter = 10 ;
		tip->status =TCP_FINWAIT1;
		break ;
	default:
		if( tip->timer_counter == 0) {
			tip->status = TCP_TIMEWAIT ;
			tip->timer_remain_msec = 10000 ; 
			tcp_write_sub(RST,tip,0,0) ;
			return 0 ;
		}
		else{
			tip->timer_counter -- ;
		}
		break ;
	} ;

	tcpwrite = 1;
	tcp_write_sub(flag,tip,0,0) ;
	tip->timer_remain_msec = 2000 ; 
	/* append end by kishida koji (2009/12/5) */
//	set_ether_header(mac, mytable.mac, IP_TYPE);			// kishida koji (2009/11/23)
//	ip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, 20, 20, 0);		// kishida koji (2009/11/23)
//	set_tcp_header(flag, tip->destaddr.sin_port, tip->destport, tip, ip, 0);		// kishida koji (2009/11/23)
//	TCNT = 0x5a00 ;  // by kishida koji
//	ether_flush(sizeof(ether_header) + 20 + 20);		// kishida koji (2009/11/23)
//	TCNT = 0x5a00 ;  // by kishida koji
/* 2003/03/07 change end */
	return 0;
}

/*kishida koji for timer*/
void tcpIntervalTimer(){
	int connid ;
	int interval ;
	interval = 5 ;
	tcpinfo		*tip;
	for( connid=0 ; connid < MAX_CONN; connid++) {
		TCNT = 0x5a00 ;
		tip=&connects[connid];
		if( tip->timer_remain_msec < interval){
			switch (tip->status) {
			case 0 :
				break ;
			case (TCP_FINWAIT1) :
			case (TCP_CLOSING):
				print(" retry tcp close/");
				tcpclose(connid) ;
				break ;
			case (TCP_TIMEWAIT):
				print(" timewait tcpfree/");
				tcpfree(connid) ;
				break ;
			default :
				print(" tcpInterval free ") ;
				tcpfree(connid) ;
				break ;
			}
		}
		else{
				tip->timer_remain_msec -= interval ;
			};
	}; // for
};
/*kishida koji for FIN timer end*/


int tcp(ip_header *ip) {
	char		*mac;
	char		flag;
	ip_header	*myip;
	unsigned int	src_ip, *p;
	unsigned int	header_size, tcp_header_size, data_size;
	tcp_header	tcp;
	struct sockaddr_in addr;
	int	i, ret;
	tcpinfo		*tip;

	// tip->myseq : seq of send data. equal to recieved ack. indicate data number which is received remote side.
	// tip->rmseq : ack of send data.  recieved seq + received data.

	TCNT = 0x5a00 ;  // by kishida koji
	header_size = ((int)ip->version_size & 0xf) * 4;
		print("tcp() h_s=%d/",header_size) ;
	ether_read((char*)&tcp, sizeof(ether_header) + header_size, sizeof(tcp_header));
	p = (int*)ip->src_ip; src_ip = *p;
		print("tcp2 src_ip=%x/",src_ip) ;
	TCNT = 0x5a00 ;
//	if((mac = query_mac(src_ip)) == 0) return -1;  // by kishida koji (2009/12/3)
	mac = ip->ether_header + 6 ;
	regist_mac(mac, src_ip) ;
		print("s mac=%x:%x:%x:%x:%x:%x ",*mac,*(mac+1),*(mac+2),*(mac+3),*(mac+4),*(mac+5)) ;
	TCNT = 0x5a00 ;  // by kishida koji
		print("r mac=%x:%x:%x:%x ",*ip->ether_header,*ip->ether_header+1,*ip->ether_header+2,*ip->ether_header+3) ;
	tcp_header_size = (tcp.header_size >> 2) & 0x3c;
	tcp_data_size = data_size = ip->data_size - header_size - tcp_header_size;
	addr.seq = tcp.src_seq ;  // kishida koji for retry TCP packet
	addr.ack = tcp.dest_seq ;  // kishida koji for retry TCP packet
			print("tcp flag=%x seq=%u ack=%u dsize=%u/",tcp.flag,tcp.src_seq,tcp.dest_seq,data_size) ; // kishida koji (2009.11.3)
//			oslog("tcp flag=%x\n",tcp.flag) ; // kishida koji (2009.11.3)
/* write_mode(2);	2003/03/07 delete */
	for(i = 0;i < MAX_CONN;i++) {
		TCNT = 0x5a00 ;  // by kishida koji
/* 2003/03/07 change start */
		tip = &connects[i];
		/* change by kishida koji (2009/11/23) */
		if(tip->destaddr.sin_addr == src_ip && tip->destaddr.sin_port == tcp.src_port && tip->destport == tcp.dest_port){
			switch (tip->status) {
			case 0 :
			case TCP_TIMEWAIT:
				continue ;
				break ;
			default :
				break ;
			} ;
		}
		else{
			continue ;
		} ;
//		flag = 0;
//		if(tip->status != 0 && tip->destaddr.sin_addr == src_ip && tip->destaddr.sin_port == tcp.src_port && tip->destport == tcp.dest_port) flag = 1;
//		if(flag == 0) continue;
		/* change end by kishida koji (2009/11/23) */
		/* for exist conection */
		cur_id = i;
//		if(tcp.flag & ACK) tip->myseq = tcp.dest_seq;  // kishida.koji for ACK check (2009.11.19)
		if(tcp.flag & SYN) {
			print("OS tcp:SYN for ex-conn\n") ;TCNT = 0x5a00 ; 
////			send RST
			return -1 ; // kishida koji (2009.11.7) 
//			tip->rmseq = tcp.src_seq + 1 ; // tip->rmseq++;  // kishida koji for retry TCP (2009.4.5)
			/* append for retry SYN by kishida koji (2009.11.3) 
			tip->time = -1;
			tip->status = TCP_SYNRCVD ; 
			set_ether_header(mac, mytable.mac, IP_TYPE);
			TCNT = 0x5a00 ;  
			myip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, 20, 28, 0);
			TCNT = 0x5a00 ; 
			set_tcp_header(SYN | ACK, tip->destaddr.sin_port, tip->destport, tip, myip, 0);
			TCNT = 0x5a00 ; 
			ether_flush(sizeof(ether_header) + 20 + 28);
			TCNT = 0x5a00 ;  
			return 0 ;*/
		};
//		if(tcp.flag & FIN) tip->rmseq++;  // kishida.koji for ACK check (2009.11.19)
		if(tcp.flag & RST) {
			switch(tip->status) {
			case TCP_LISTEN:
			case TCP_ESTAB:
			case TCP_LASTACK:
				tip->status = TCP_CLOSING;
				addr.sin_port = tcp.src_port;
				addr.sin_addr = src_ip;
				(*tcprecv[tip->index])(TCP_CLOSE, i, &addr);
				break;
			}
			tcpfree(i);
			return 0;
		}
		switch(tip->status) {
		case TCP_LISTEN:
			if(tcp.flag & (SYN | ACK)) {
				tcp_write_sub(ACK,tip,0,0) ;
//				set_ether_header(mac, mytable.mac, IP_TYPE);		// replace to tcp_write_sub by kishida koji (2009/11/21)
//				myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0);	// replace to tcp_write_sub by kishida koji (2009/11/21)
//				set_tcp_header(ACK, tcp.src_port, tcp.dest_port, tip, myip, 0);	// replace to tcp_write_sub by kishida koji (2009/11/21)
//				ether_flush(sizeof(ether_header) + 20 + 20);		// replace to tcp_write_sub by kishida koji (2009/11/21)
				tip->status = TCP_ESTAB;
				addr.sin_port = tcp.src_port;
				addr.sin_addr = src_ip;
				tip->destaddr = addr;
				tip->destport = tcp.dest_port;
				tcp_data_offset = sizeof(ether_header) + header_size + tcp_header_size;
				(*tcprecv[tip->index])(TCP_BEGIN, i, &addr);
				tcp_data_offset = 0;
				tip->timer_remain_msec = 3600 * 1000 ;
			}
			break;
		case TCP_SYNRCVD:
		  /* append by kishida.koji for SYN+ACK lost  --STRAT-- */
			if(tcp.flag & SYN){			// retry SYN recieved (maybe SYN-ACK lost)
//			  if((mac = query_mac(passive_destaddr.sin_addr)) == 0) return -1;
				tip->fActive = 0;
//			    tip->rmseq = seq + 1;
			    tip->status = TCP_SYNRCVD;
//			    tip->destaddr = passive_destaddr;
//			    tip->destport = passive_destport;
			    flag = SYN | ACK;
//				tip->myseq = sequence;
				tip->time = -1;
//			 tip->index = index;
				tcp_write_sub(flag,tip,0,0); // kishida koji (2009/11/23)
//				set_ether_header(mac, mytable.mac, IP_TYPE);		// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				myip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, 20, 28, 0);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				set_tcp_header(flag, tip->destaddr.sin_port, tip->destport, tip, myip, 0);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				ether_flush(sizeof(ether_header) + 20 + 28); // kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
				break ;
			}
//			else	// kishida.koji for TCP retry (2009.4.5)
		  /* append by kishida.koji for SYN+ACK lost  --END-- ( 2009.5.10) */
//			if(tcp.flag & PSH) {			// kishida.koji for TCP retry (2009.4.5)
			else if(data_size > 0) {			// kishida.koji for TCP retry (2009.6.10)
				tip->status = TCP_ESTAB;	// kishida.koji for TCP retry (2009.4.5)
			}								// kishida.koji for TCP retry (2009.4.5)
			else	if(tcp.flag & ACK) {			// kishida.koji for TCP retry (2009.4.5)
//			if(tcp.flag & ACK) {				// kishida.koji for TCP retry (2009.4.5)
				tip->status = TCP_ESTAB;
				addr.sin_port = tcp.src_port;
				addr.sin_addr = src_ip;
				tip->destaddr = addr;
				tip->destport = tcp.dest_port;
				tcp_data_offset = sizeof(ether_header) + header_size + tcp_header_size;
				(*tcprecv[tip->index])(TCP_BEGIN, i, &addr);
				tcp_data_offset = 0;
				tip->timer_remain_msec = 3600 * 1000 ;
				break ;
			}
			else{							// kishida.koji for TCP retry (2009.4.5)
				break;						
			};								// kishida.koji for TCP retry (2009.4.5)
///		case TCP_LASTACK:			// kishida koji for FIN retry. moving from after TCP_ESTAB (2009.9.6). 
///			if( (tcp.flag & FIN) {
///				tip->status = TCP_ESTAB ;	// kishida koji for FIN retry.	(2009.11.19)
///			}
///			else if(tcp.flag & ACK) {
///				addr.sin_port = tcp.src_port;
///				addr.sin_addr = src_ip;
///				(*tcprecv[tip->index])(TCP_CLOSE, i, &addr);
///				tcpfree(i);
///				break ;			// kishida koji for FIN retry.	 (2009.9.6)
///			}					// kishida koji for FIN retry.	 (2009.9.6)
///			else{					// kishida koji for FIN retry.	 (2009.9.6)
///				etherread
///				break ;
///			};
		case TCP_ESTAB:
			if(tcp.flag & FIN) {
				tip->myseq = tcp.dest_seq;  // kishida.koji for ACK check (2009.11.19)
				tip->rmseq = tcp.src_seq + 1 ; // kishida.koji for ACK check (2009.11.19)
				print("OS ESTAB-FIN\n") ;
				tcp_write_sub(ACK | FIN,tip,0,0) ; // kishida koji (2009/11/23)
//				set_ether_header(mac, mytable.mac, IP_TYPE);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				set_tcp_header(ACK | FIN, tcp.src_port, tcp.dest_port, tip, myip, 0);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				ether_flush(sizeof(ether_header) + 20 + 20);// kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
				tip->status = TCP_LASTACK;
				/* append by kishida koji (2009/11/21) */
				tip->timer_remain_msec = 20 * 1000 ;
				addr.sin_port = tcp.src_port;
				addr.sin_addr = src_ip;
				(*tcprecv[tip->index])(TCP_CLOSE, i, &addr);
				/* append end */
				break;
			}			
//			tip->rmseq += data_size;				// kishida.koji for TCP retry (2009.4.5)
			tip->myseq = tcp.dest_seq;  // kishida.koji for ACK check (2009.11.19)
			tip->rmseq  = tcp.src_seq + data_size ;	// kishida.koji for TCP retry (2009.4.5)
			addr.sin_port = tcp.src_port;
			addr.sin_addr = src_ip;
			tip->destaddr = addr;
			tip->destport = tcp.dest_port;
			tip->timer_remain_msec = 3600 * 1000 ;
			tcp_data_offset = sizeof(ether_header) + header_size + tcp_header_size;
			tcpwrite = 0;	
			if(data_size > 0){				
				(*tcprecv[tip->index])(TCP_DATA, i, &addr);
			}
			else{
				(*tcprecv[tip->index])(TCP_ACK, i, &addr);
			};
			tcp_data_offset = 0;
			TCNT = 0x5a00 ;  // by kishida koji
			if(tcpwrite == 0 && data_size > 0 ) tcp_write_sub(ACK,tip,0,0) ; // kishida koji (2009/12/12)		
//			if(tcpwrite == 0 ) {		// kishida koji (2009/12/12)
//				set_ether_header(mac, mytable.mac, IP_TYPE); // kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0); // kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				set_tcp_header(ACK, tcp.src_port, tcp.dest_port, tip, myip, 0); // kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//				ether_flush(sizeof(ether_header) + 20 + 20); // kishida koji (2009/11/23)
//				TCNT = 0x5a00 ;  // by kishida koji
//			}			// kishida koji (2009/12/12)
			break;
		case TCP_LASTACK:
			/* append for ACK check by kishida.koji  (2009.11.19) */
			if(tcp.flag & FIN ) {
				tip->myseq = tcp.dest_seq;  
				tip->rmseq = tcp.src_seq + 1 ;
				print("OS LASTACK FIN\n") ;
				 tcp_write_sub(ACK | FIN, tip,0,0) ; // kishida koji (2009.11.23)
//				set_ether_header(mac, mytable.mac, IP_TYPE);		TCNT = 0x5a00 ; 
//				myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0);	TCNT = 0x5a00 ;
//				set_tcp_header(ACK | FIN, tcp.src_port, tcp.dest_port, tip, myip, 0);	TCNT = 0x5a00 ;
//				ether_flush(sizeof(ether_header) + 20 + 20);		TCNT = 0x5a00 ;
				tip->status = TCP_LASTACK;
				break;
			}
			else if(tcp.flag & ACK) {
			/* end append */
//			if(tcp.flag & ACK) {	// kishida.koji for ACK check (2009.11.19)
				if( tcp.src_seq == tip->rmseq && tcp.dest_seq == tip->myseq+1 ){  // kishida.koji for ACK check (2009.11.19)
//					addr.sin_port = tcp.src_port;
//					addr.sin_addr = src_ip;
//					(*tcprecv[tip->index])(TCP_CLOSE, i, &addr);
					print("OS LASTACK ACK ok\n") ;
					tcpfree(i);
			/* append for ACK check by kishida.koji  (2009.11.19) */
				}
				else{ 
					print("OS LASTACK ACK ng\n") ;
					if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
				};
				/* end append */
			}
			else{
					print("OS LASTACK ill-msg\n") ;
					if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
			};
			/* append for ACK check by kishida.koji  (2009.11.19) */
			break;
		case TCP_FINWAIT1:
			/* append by kishida koji (2009.11.21) */
			if(tcp.flag & (ACK | FIN) ) {
				if( tcp.src_seq == tip->rmseq && tcp.dest_seq == tip->myseq+1 ){ // check ACK which is ack for FIN
					print("FW1-ACK|FIN/") ;
					tip->myseq = tcp.dest_seq;  
					tip->rmseq = tcp.src_seq + 1;
					tcp_write_sub(ACK,tip,0,0) ;
					tip->status = TCP_TIMEWAIT ;
					tip->timer_remain_msec = 10000 ;
				}
				else{
					print("FW1-FIN/") ;
					tip->myseq = tcp.dest_seq;  
					tip->rmseq = tcp.src_seq + 1 ;
					tcp_write_sub(ACK|FIN,tip,0,0) ;
					tip->status = TCP_LASTACK;
				} ;
			}
			else if(tcp.flag & ACK ) {
				if( tcp.src_seq == tip->rmseq && tcp.dest_seq == tip->myseq+1 ){ // check ACK which is ack for FIN
					print("FW1-ACK") ;
					tip->myseq = tcp.dest_seq;  
					tip->rmseq = tcp.src_seq + 1 ;
					tcp_write_sub(ACK,tip,0,0) ;
					tip->status = TCP_FINWAIT2 ;
				}
				else{
					print("FW1-irr ACK") ;
					if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
				} ;				
			}
			else if(tcp.flag & FIN ) {
				print("FW1-FIN") ;
				tip->myseq = tcp.dest_seq;  
				tip->rmseq = tcp.src_seq + 1;
				tcp_write_sub(ACK,tip,0,0) ;
				tip->status = TCP_CLOSING ;				
			}
			else{
				print("FW1-ill msg") ;
				if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
			};
			break ;
			/* end append */
		case TCP_FINWAIT2:
			/* append by kishida koji (2009.11.21) */
			if(tcp.flag & (ACK | FIN) ) {
					print("FW2-ACK|FIN") ;
					tip->myseq = tcp.dest_seq;  
					tip->rmseq = tcp.src_seq + 1 ;
					tcp_write_sub(ACK,tip,0,0) ;
					tip->status = TCP_TIMEWAIT ;
					tip->timer_remain_msec = 10000 ;
			}
			else if(tcp.flag & ACK ) {
					print("FW2-ACK") ;
					if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
			}
			else  if(tcp.flag & FIN ) {
				print("FW2-FIN") ;
				tip->myseq = tcp.dest_seq;  
				tip->rmseq = tcp.src_seq + 1;
				tcp_write_sub(ACK,tip,0,0) ;
				tip->status = TCP_TIMEWAIT ;
				tip->timer_remain_msec = 10000 ;			
			}
			else {
				print("FW2-ill msg/") ;
				if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
			};
			/* end append */

/* comment out by kishida koji  (2009/11/21) 
			flag = 0;
			if(tip->fActive == 0) {
				if(tcp.flag & ACK) tip->status = TCP_FINWAIT2;
				if(tcp.flag & FIN) flag = ACK | RST;
			} else {
				if(tcp.flag & ACK) flag = ACK;
			}
			if(flag != 0) {
				set_ether_header(mac, mytable.mac, IP_TYPE);
				TCNT = 0x5a00 ;  // by kishida koji
				myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0);
				TCNT = 0x5a00 ;  // by kishida koji
				set_tcp_header(flag, tcp.src_port, tcp.dest_port, tip, myip, 0);
				TCNT = 0x5a00 ;  // by kishida koji
				ether_flush(sizeof(ether_header) + 20 + 20);
				TCNT = 0x5a00 ;  // by kishida koji
				tcpfree(i);
			}
*/
			break;
			case TCP_CLOSING:
			/* append by kishida koji (2009.11.21) */
			if(tcp.flag & ACK ) {
				if( tcp.src_seq == tip->rmseq && tcp.dest_seq == tip->myseq+1 ){ // check ACK which is ack for FIN
					print("CLS-ACK/") ;
					tip->status = TCP_TIMEWAIT ;
				}
				else print("CLS-illACK/") ;
					if(data_size > 0) {
						char dummy[1024] ;
						tcp_read(dummy,1024) ;
					};
			} ;
			break ;
			/* end append */
		} ;
		return 0;
/* 2003/03/07 change end */
	} ; // end of for-loop
	if(tcp.flag & FIN) {
		tcpinfo dummy;
		dummy.rmseq = tcp.src_seq + 1;
		dummy.myseq = tcp.dest_seq;
		tcp_write_sub(ACK,tip,0,0) ; // kishida koji (2009/11/23)
//		set_ether_header(mac, mytable.mac, IP_TYPE) ;	// kishida koji (2009/11/23)
//		TCNT = 0x5a00 ;  // by kishida koji
//		myip = set_ip_header(IP_TCP, src_ip, 20, 20, 0);	// kishida koji (2009/11/23)
//		TCNT = 0x5a00 ;  // by kishida koji
//		set_tcp_header(ACK, tcp.src_port, tcp.dest_port, &dummy, myip, 0);	// kishida koji (2009/11/23)
//		TCNT = 0x5a00 ;  // by kishida koji
//		ether_flush(sizeof(ether_header) + 20 + 20);	// kishida koji (2009/11/23)
//		TCNT = 0x5a00 ;  // by kishida koji
		return 0;
	}
	for(i = 0;i < MAX_TCPPROC;i++) {
		TCNT = 0x5a00 ;  // by kishida koji
		if(tcpproc[i] != 0) {
			addr.sin_port = tcp.src_port;
			addr.sin_addr = src_ip;
/* 2003/03/07 change start */
			passive_destaddr = addr;
			passive_destport = tcp.dest_port;
/* 2003/03/07 change end */
			tcp_data_offset = sizeof(ether_header) + header_size + tcp_header_size;
			tcp_data_size = data_size;
			ret = (*tcpproc[i])(tcp.dest_port, &addr, tcp.flag, tcp.src_seq);
			tcp_data_offset = 0;
			if(ret == 0) return 0;
		}
	}
	return -1;
}

int tcp_regport(int (*proc)(unsigned short, struct sockaddr_in*, unsigned char, int)) {
	int	i;
	
	for(i = 0;i < MAX_TCPPROC;i++) {
		if(tcpproc[i] == 0) {
			tcpproc[i] = proc;
			return i;
		}
	}
	return -1;
}

int tcp_unregport(int (*proc)(unsigned short, struct sockaddr_in*, unsigned char, int)) {
	int	i;
	
	for(i = 0;i < MAX_TCPPROC;i++) {
		if(tcpproc[i] == proc) {
			tcpproc[i] = 0;
			return 0;
		}
	}
	return -1;
}

void set_tcpaddr(struct sockaddr_in *addr, unsigned short port) {
/* 2003/03/07 change start */
	active_destaddr = *addr;
	active_destport = port;
/* 2003/03/07 change end */
}

int tcp_read(char *data, int len) {
	int size;

	if(tcp_data_offset == 0) return -1;
	if(tcp_data_size > len) size = len;
	else size = tcp_data_size;
	ether_read(data, tcp_data_offset, size);
	return size;
}


int tcp_write(int _id, char *data, int size) {
	char		*mac, flag;
	int		id;
	ip_header	*ip;
	tcpinfo		*tip;

/*  append by kishida koji (2009.11.21) */
	if(ip_enable == 0) return -1;
	if(_id == -1) id = cur_id;
	else id = _id;
	tip = &connects[id];
	if( size > 0 ) tcp_write_sub( ACK|PSH, tip , data, size) ;
	else tcp_write_sub( ACK, tip , data, 0) ;
/*append end*/	
/* 2003/03/07 change start */
/* comment out by kishida koji (2009.11.21) 
	if(ip_enable == 0) return -1;
	if(_id == -1) id = cur_id;
	else id = _id;
	tip = &connects[id];
	if((mac = query_mac(tip->destaddr.sin_addr)) == 0) return -1;
	set_ether_header(mac, mytable.mac, IP_TYPE);
	ip = set_ip_header(IP_TCP, tip->destaddr.sin_addr, 20, 20 + size, 0);
	flag = (tcpwrite == 0) ? ACK | PSH : PSH;  
	set_tcp_header(flag, tip->destaddr.sin_port, tip->destport, tip, ip, data);
	ether_write(data, sizeof(ether_header) + 20 + 20, size);
	ether_flush(sizeof(ether_header) + 20 + 20 + size);
2009.11.21 end */
	tcpwrite = 1;
/* 2003/03/07 change end */
	return size;
}

int tcp_init() {
/* 2003/03/07 change start */
	TCNT = 0x5a00 ;  // by kishida koji
	memset( &connects[0], 0, sizeof( connects ) );
	memset( &tcprecv[0], 0, sizeof( tcprecv ) );
	memset( &tcpproc[0], 0, sizeof( tcpproc ) );
/* 2003/03/07 change end */
	tcp_data_offset = 0;
	sockid_alloter = 0 ;
}
